/* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * <pre lang="ja">
 * (_(    
 * ( `)   쥹ܡ׎ʡ
 * (      )     : 2004/06/12
 *      񤤤  : ؤ41
 * (___)__)   Ď؎ˎގ: 
 *                        jslib١ѤơɽѲĤˤ
 *            
 * </pre>
 */


include("chrome://jslib/content/rdf/rdfFile.js");

const kMoz2chAboneRDFName = "abone.rdf";
const kMoz2chAboneURIPrefix = "uri:abone:";

var reg_exp = new RegExp().compile("h?t?tp://[-_.!~*'a-zA-Z0-9;/?:@&=+$,%#]+","g");
var reg_plus = new RegExp().compile("[+]","g");
var reg_ques = new RegExp().compile("[?]","g");

var moz2chAbone = {

    rdf: null,  //jslibrdf֥
    ds: null,	//nsIRDFDataSource

    nameAboneArray: [],  //ܡɽ
    mailAboneArray: [],
    idAboneArray: [],
    wordAboneArray: [],
    linkAboneArray: [],

    init: function() {
	var moz2chDir = kDirectoryService
	               .get("ProfD", Components.interfaces.nsIFile);
    	
	moz2chDir.append(kMoz2chDirName);
	if (!moz2chDir.exists())
	moz2chDir.create(moz2chDir.DIRECTORY_TYPE, 0755);
	
	var file = moz2chDir.clone();
	file.append(kMoz2chAboneRDFName);
	
	this.rdf = new RDFFile( file.path );
	this.ds = this.rdf.getDatasource();
	this.rdf.addRootSeq( "uri:abone:name" );
	this.rdf.addRootSeq( "uri:abone:mail" );
	this.rdf.addRootSeq( "uri:abone:id" );
	this.rdf.addRootSeq( "uri:abone:word" );
	this.rdf.addRootSeq( "uri:abone:link" );
	
	this.makeAboneCollection();
    },

    makeAboneCollection: function() {
        var seq, nodes, reg;
      
        this.nameAboneArray = [];
        this.mailAboneArray = [];
        this.idAboneArray = [];
        this.wordAboneArray = [];
	this.linkAboneArray = [];

        seq = this.rdf.getRootSeq("uri:abone:name");
        nodes = seq.getSubNodes();
        for(var i=0; i<nodes.length; i++) {
            reg = nodes[i].getAttribute(kMoz2chNS + "word");
            this.nameAboneArray.push(new RegExp().compile(reg)); 
        }

        seq = this.rdf.getRootSeq("uri:abone:mail");
        nodes = seq.getSubNodes();
        for(var i=0; i<nodes.length; i++) {
            reg = nodes[i].getAttribute(kMoz2chNS + "word");
            this.mailAboneArray.push(new RegExp().compile(reg)); 
        }

        seq = this.rdf.getRootSeq("uri:abone:id");
        nodes = seq.getSubNodes();
        for(var i=0; i<nodes.length; i++) {
            reg = nodes[i].getAttribute(kMoz2chNS + "word");
            this.idAboneArray.push(new RegExp().compile(reg)); 
        }

        seq = this.rdf.getRootSeq("uri:abone:word");
        nodes = seq.getSubNodes();
        for(var i=0; i<nodes.length; i++) {
            reg = nodes[i].getAttribute(kMoz2chNS + "word");
            this.wordAboneArray.push(new RegExp().compile(reg)); 
        }

        seq = this.rdf.getRootSeq("uri:abone:link");
        nodes = seq.getSubNodes();
        for(var i=0; i<nodes.length; i++) {
            reg = nodes[i].getAttribute(kMoz2chNS + "word");
            this.linkAboneArray.push(new RegExp().compile(reg)); 
        }
    },

    shouldAbone: function(name, mail, id, msg) {

	//moz2chSure.parse()ǸƤФ롢̾᡼롢Id(), ʸ
	//Ƥܡ󤹤٤롣
        name = name.replace(/<\/b>/g,"");
        for( var i=0; i<this.nameAboneArray.length; i++ ) {
            if ( this.nameAboneArray[i].test(name) ) {
                 return true;
            }
        }

        for( var i=0; i<this.mailAboneArray.length; i++ ) {
            if ( this.mailAboneArray[i].test(mail) ) {
                 return true;
            }
        }

        for( var i=0; i<this.idAboneArray.length; i++ ) {
            if ( this.idAboneArray[i].test(id) ) {
                 return true;
            }
        }

        for( var i=0; i<this.wordAboneArray.length; i++ ) {
            if ( this.wordAboneArray[i].test(msg) ) {
                 return true;
            }
        }

	return false;
    },

    linkCheck: function( res ) {
	try{
	    var place;
	    var repl = new Array();
	    var change_exp = new Array();
	    
	    place = res.match(reg_exp);
	    
	    if(!place) return res;
	    for(var i=0; i<place.length; i++){
		repl = place[i].split(":");
		repl[1] = repl[1].replace(reg_plus,"\\+");
		repl[1] = repl[1].replace(reg_ques,"\\?");
		change_exp.push(new RegExp().compile("("+repl[0]+"):("+repl[1]+")", "g"));
	    }

	    for( var i=0; i<this.linkAboneArray.length; i++ ) {
		for( var j=0; j<place.length; j++){
		    if( this.linkAboneArray[i].test(place[j])){
			res = res.replace(change_exp[j],"$1d:$2");
		    }
		}
	    }
	    return res;
	}catch(e){ moz2ch.debug(e); return res; }
    },

    add: function ( category, text ) {
        try{
	    text = text.replace(reg_plus,"\\+");
	    //catogory"name, mail, id, word"ʴ
            var seq = this.rdf.getRootSeq("uri:abone:"+ category.toLowerCase());
            var nodes = seq.getSubNodes();
      	    
            for(var i=0; i<nodes.length; i++) {
                if( text == nodes[i].getAttribute(kMoz2chNS + "word")) {
      	            //ϿѤߎӎŎ
                    moz2ch.debug("moz2chAbone \"" + text + "\" is already registered");
                    return;
                }
            }

            //ϿƤʤ
            var res = this.rdf.getAnonymousResource();
            var node = seq.addNode(res.getSubject());
            node.setAttribute( kMoz2chNS + "word" , text );
			this.makeAboneCollection();

			var tab_node = moz2ch.sureView.element.mTabContainer.childNodes;
			for(var i=0; i<tab_node.length; i++){
				if(tab_node[i].sure){
					moz2ch.sureView.reloadTabAll(tab_node[i]);
				}
			}
	}catch(e){
	    moz2ch.debug(e);
	}
    },

    remove: function ( category, text ) {
        try{
            var seq = this.rdf.getRootSeq("uri:abone:"+ category.toLowerCase());
            var nodes = seq.getSubNodes();

            for(var i=0; i<nodes.length; i++) {
                if( text == nodes[i].getAttribute(kMoz2chNS + "word")) {
      	            nodes[i].remove();
					this.makeAboneCollection();
					var tab_node = moz2ch.sureView.element.mTabContainer.childNodes;
					for(var i=0; i<tab_node.length; i++){
						if(tab_node[i].sure){
							moz2ch.sureView.reloadTabAll(tab_node[i]);
						}
					}
					return;
                }
            }
	}catch(e){
	    moz2ch.debug(e);
	}
    },

    update: function () {
        this.rdf.flush();
        this.init();
    },
};

//Ūˤǽ
moz2chAbone.init();


