/* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * <pre lang="ja">
 * (_(    
 * ( `)   2chĥĥ꡼饹ʡ
 * (      )     : 2004/05/29
 *      񤤤  : ؤ41
 * (___)__)   Ď؎ˎގ: 
 *                        ʬ䤷
 *            
 * </pre>
 */

function moz2ch2chItaTree(title, url) {
    this.base = moz2chItaTree;
    this.base(title, url);
    if(!this.url){
	if(nsPreferences.getLocalizedUnicharPref("moz2ch.itatreeurl")){
	    this.url = nsPreferences.getLocalizedUnicharPref("moz2ch.itatreeurl");
	    if(this.url == "http://www.ff.iij4u.or.jp/~ch2/bbsmenu.html"){
		this.url = "http://menu.2ch.net/bbsmenu.html";
		nsPreferences.setUnicharPref("moz2ch.itatreeurl", this.url);
	    }
	}else{
	    this.url = "http://menu.2ch.net/bbsmenu.html";
	    nsPreferences.setUnicharPref("moz2ch.itatreeurl", this.url);
	}
    }
    this.getTitle =  function () {
        return moz2chCharset.euc2uni("ͤ");
    };

    this.bbsId = "2ch";
    this.rdfRootURI = "http://www.2ch.net/";

    // BBSǥ쥯ȥꥲȡ
    var dir = new Dir(this.getBBSDir());
    //var dir = IO.getFileWithPath(this.getBBSDir());

    dir.append(kMoz2chRDFName);
    file = kIOService.newFileURI(dir.nsIFile).spec;
    //file = IO.newURI(dir).spec;

    // ǡ򥻥ơ
    var ds = kRDFService.GetDataSourceBlocking(file); 
	this.datasource = ds;
	
    // RDFκǤäȤ
    var res = kRDFService.GetResource(this.rdfRootURI); //͡ߥ󥰤Ѥ
    this.rdfRoot = kRDFContainerUtils.MakeSeq(this.datasource, res);

    this.changeDat = null;
    this.getsabaDat(kMoz2ch2chSabaFileName);
}


///////////
// 
moz2ch2chItaTree.prototype.itaTreeLeaf = "bbsmenu.html";

const kMoz2ch2chSabaFileName = "sabadat.txt";
/////////////////////////
// extends moz2chTreeData
moz2ch2chItaTree.prototype = new moz2chItaTree();

/**
 * bbsmenu.htmlѡ
 * @return true
 */

moz2ch2chItaTree.prototype.dataConvert =
function () {
    if(this.changeDat){
		this.changeDat_Old = this.changeDat;
		this.changeDat = null;
    }
    this.changeDat = new Array();

    // sjis -> unicode
    var data = moz2chCharset.sjis2uni(this.data);
    data = data.replace(/<!--(.|\n)*?-->/g,"");

	return data;
};

moz2ch2chItaTree.prototype.mainParse =
function (data) {
    var blocks = new Array();
    blocks = data.split(/<br><br>/gi);
    var categoryRe = /<b>([^<]+?)<\/b>/i;
    var urlRe = /(http:\/\/[^>]+\/).*?>([^<]+?)<\/a>/gi;

    // to remove needless blocks
    for (var i = 1; i < blocks.length - 2; i++) {
	if( i != (blocks.length - 4) && i != (blocks.length - 5)){
	    var ret = new Array();
	    ret = categoryRe.exec(blocks[i]);
	    var category = this.addCategory(ret[1]);
	    var j = 1;
	    do {
		ret = null;
		ret = new Array();
		ret = urlRe.exec(blocks[i]);
		if (ret){
		    this.addIta(category, ret[2], ret[1]);
		    this.changeDat.push(ret[1] + " " + ret[2]);
		}
	    } while (ret);
	}
    }

    // external ita tree file
    this.readOtherBrd();

    this.datasource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush();

    var text = this.changeDat.join("\r\n");
    var f = new File(this.getMoz2chDir());
    f.append(kMoz2ch2chSabaFileName);
    f.open("w", kMoz2chDataFilePerm);
    f.write(moz2chCharset.uni2sjis(text));
    f.close();

    this.checkItaMoveAndCreate();
};

/**
 * Ĥɤ߹ࡣ
 * Ĥ<profile>/Moz2ch/bbs/2ch/other.brd2channel.brdǳǼ롣
 */

moz2ch2chItaTree.prototype.checkExistOtherBrd =
function () {
    var f = new Dir(this.getBBSDir());
    f.append(this.itaTreeOtherBrd);
    var path = f.path;

    var f = new File(path);

    var brd;
    if (!f.exists()) {
        brd = moz2ch.getString("defaultOtherBrd");
        f.open("w", 0700);
        f.write(moz2chCharset.uni2sjis(brd));
        f.close();
    } else {
        f.open("r");
        brd = moz2chCharset.sjis2uni(f.read());
        f.close();
    }
	return brd;
};

moz2ch2chItaTree.prototype.parseOtherBrd =
function (brd) {
    var category = null;
    for (var i = 1; i < brd.length; i++) {
        var tokens = brd[i].split("\t");
        if (tokens.length >= 4 && category) {
            // this is ita
            var url = "http://" + tokens[1] + "/" + tokens[2] + "/";
	    tokens[3] = tokens[3].replace(/\s/g,"");
	    this.addIta(category, tokens[3], url);
	    this.changeDat.push(url + " " + tokens[3]);
        } else if (tokens.length >= 2) {
            // this is category
            category = this.addCategory(tokens[0]);
            // category.open = (1 == tokens[0]);
        }
    }
};

moz2ch2chItaTree.prototype.checkItaMoveAndCreate =
function () {
    try{
	var i, j;
	var saba_flag = -1;
	var str = null;
	var saba = new Array();
	var oldSaba = new Array();
	var oldIta = new Array();
	var ita = new Array();
	var datDir = null;
	var oldDatDir = null;
	var oldDatSaba = null;
	var fileName = null;
	var fileList = new Array();
	var newFileName = null;
	var newFile = null;
	var oldFile = null;
	
	for(i=0; i<this.changeDat.length; i++){
	    str = this.changeDat[i].split(" ")[0];
	    saba[i] = str.split("://")[1].split("/")[0];
	    ita[i] = str.split("://")[1].split("/")[1];
	}
	for(i=0; i<this.changeDat_Old.length; i++){
	    str = this.changeDat_Old[i].split(" ")[0];
	    oldSaba[i] = str.split("://")[1].split("/")[0];
	    oldIta[i] = str.split("://")[1].split("/")[1];
	} 
	for(i=0; i<this.changeDat.length; i++){
	    for(j=0; j<this.changeDat_Old.length; j++){
		if(ita[i] && (ita[i] == oldIta[j])){
		    if(saba[i] == oldSaba[j])
			break;
		    else
			saba_flag = j;
		}
	    }
	    if(saba_flag != -1){
		moz2ch.debug("Ita " + ita[i] +" moved from " + oldSaba[saba_flag] + " to " + saba[i] + ".");
		
        oldDatDir = new Dir(this.getBBSDir());
		oldDatDir.append(oldSaba[saba_flag]);
		oldDatDir.append(ita[i]);
		if(oldDatDir.exists()){
		    fileList = oldDatDir.readDir();
		    if(fileList.length > 0){
			datDir = new Dir(this.getBBSDir());
			datDir.append(saba[i]);
			if(!datDir.exists())
                datDir.create(kMoz2chDataDirPerm);
			datDir.append(ita[i]);
			if(!datDir.exists())
			    datDir.create(kMoz2chDataDirPerm);
		    if(window.navigator.platform.match(/Win/i)){
			    for(j=0; j<fileList.length; j++){
                    fileName = fileList[j].path.split(ita[i])[1].split("\\")[1];
			        newFileName = datDir.path + "\\" + fileName;
                    newFile = new File(newFileName);
			        if(newFile.exists())
				        newFile.remove();
			        oldFile = new File(oldDatDir.path);
			        oldFile.append(fileName);
			        oldFile.copy(newFileName);
			        oldFile.remove();
                }
			}else{
			    for(j=0; j<fileList.length; j++){
                    fileName = fileList[j].path.split(ita[i])[1].split("/")[1];
			        newFileName = datDir.path + "/" + fileName;
                    newFile = new File(newFileName);
			        if(newFile.exists())
				    newFile.remove();
			        oldFile = new File(oldDatDir.path);
			        oldFile.append(fileName);
			        oldFile.copy(newFileName);
			        oldFile.remove();
			    }
			}
			oldDatDir.remove();
			oldDatDir = new Dir(this.getBBSDir());
			oldDatDir.append(oldSaba[saba_flag]);
			if(oldDatDir.readDir().length == 0)
			oldDatDir.remove();
		    }
		}
	    }

	    saba_flag = -1;
	}
    }catch(e){ moz2ch.debug(e); }
};
