/* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * <pre lang="ja">
 * (_(    
 * ( `)   Υ饹ʡ
 * (      )     : 2005/01/14
 *      񤤤  : ˼⤸顼
 * (___)__)   ȥӥݥ: (ϡ)(ϡ) tRZ80FPU5k
 *                        ؤ41
 *                        
 *                        
 *            
 *            
 * </pre>
 */

Array.prototype.clone = function(){
    return Array.apply(null,this)
}

function moz2ch2chSure(ita, title, url) {
    this.base = moz2chSure;
    this.base(ita, title, url);

    this.bbsId = "2ch";
    var a = this.url.split("/");
    if ( moz2chSureIsPathInfo( url ) ) {
        // http://pc.2ch.net/test/read.cgi/tech/1024757183/l50
        this.datID = a.pop(); 
        if ( ! this.datID.match(/[0-9]{5}/)) { //datIDθ"/"̵б
            this.datID = a.pop(); // remove last null (or nonused) string
        }
        this.itaID = a.pop();
        this.sabaID = a.slice(2, a.length - 2).join("/");
    } else if ( moz2chSureIsKey( url ) ){
        //http://baniisan.s12.xrea.com/x/test/read.cgi?bbs=moz2ch&key=026040969
        var b = a.pop();
        b = b.replace(/[?=&]/g, "/" );
        b = b.split("/");
        this.datID = b.slice(4,5);
        this.itaID = b.slice(2,3);
        this.sabaID = a.slice(2, a.length - 1).join("/");
    } else if ( moz2chSureIsLocalInfo( url ) ){
		//file:///C:\..../1234567890.dat
		var b = a.pop()
		b = b.replace(/[.]/g, "/" );
        b = b.split("/");
        this.datID = b.slice(0,1);
		this.itaID = "moz2ch"
		this.sabaID = "baniisan.s12.xrea.com"
	}
    this.sureAcq = this.ita.getAttribute(this.datID + ".dat", "sureAcq");
    this.sureClassName = "moz2ch2chSure";
}

/////////////////////
// extends moz2chSure
moz2ch2chSure.prototype = new moz2chSure();

/////////////////
// parse the data

moz2ch2chSure.prototype.dataConvert =
function () {
	var data;
	if(this.sabaID != "be.2ch.net"){
	    data = moz2chCharset.sjis2uni(this.data);
	}else{
	    data = moz2chCharset.euc2uni(this.data);
	}

	// NULLХкޤʤन
	// data = data.replace(/\0/g, "*");
	// $üʸƤޤΤǡ餫$$Ѵ
	data = data.replace(/\$/g, "$$$$");

	// &ʸк
	data = this.checkEntity(data);

	return data;
};

moz2ch2chSure.prototype.makeSabun =
function () {
	var sabun;
	if(this.sabaID != "be.2ch.net"){
	    sabun = moz2chCharset.sjis2uni(this.sabun);
	}else{
		sabun = moz2chCharset.euc2uni(this.sabun);
	}
    sabun = sabun.replace(/\$/g, "$$$$");
    sabun = sabun.replace(/&amp([^;])/gi, "&$1");

	return sabun;
};

moz2ch2chSure.prototype.mainParse =
function (lines, sabun_lines) {
	var delimiter = "<>";
	var abone_array = moz2chAbone.linkAboneArray.length;
	
	if (lines.length == 0) {
	    moz2ch.debug(this.sureClassName + ".parse: Parse Error, Do not save the data!");
	    return false;
	}
	
	if((this.old_URL != this.getDataURL()) || !this.old_html || !this.sabun){
	    this.old_URL = this.getDataURL();
	    
	    html = new Array(lines.length - 1);
	    this.old_html = new Array(lines.length - 1);
	    this.aboneRes = new Array(lines.length - 1);
	    html[0] = this.htmlHeader;
	    
	    //1쥹ܤSUBJECTäƤΤ̤˽
	    var ary = lines[0].split(delimiter);
	    if (ary.length < 2){
		delimiter=",";
		ary=ary[0].split(delimiter);
	    }
	    if (ary.length < 2) return false;
	    html[0] = html[0].replace(/<THREADNAME\/>/g, ary[4]);
	    if(this.title == moz2ch.getString("untitled"))
		this.title = ary[4];

		this.old_html[0] = this.parseRes(1, ary[0], ary[1], ary[2], ary[3]);

	    if (! moz2chAbone.shouldAbone(ary[0], ary[1], ary[2], ary[3])){ // name, mail, id, msg
			ary[2] = this.beIdLink(ary[2]);
			this.aboneRes[0] = 0;
			html[0] += this.old_html[0];
	    }else{
			this.aboneRes[0] = 1;
		}

	    if(this.sureAcq == 0){
			this.old_html[0] = this.old_html[0].replace('<b class="new">New!</b>', "");
	    }

	    //2쥹ܰʹߤƱʤΤǤ뤰
	    var start = ( lines.length - moz2ch.sureCount > 1)? lines.length - moz2ch.sureCount : 1;
	    for (var i = start; i < (lines.length - 1); i++) {
		var ary = lines[i].split(delimiter);
		if (ary.length < 2){
		    delimiter=",";
		    ary=ary[0].split(delimiter);
		}
		if (ary.length < 2) break;

	    ary[2] = this.beIdLink(ary[2]);
	    if(abone_array != 0)
		ary[3] = moz2chAbone.linkCheck(ary[3]);
	    this.old_html[i] = this.parseRes(i + 1, ary[0], ary[1], ary[2], ary[3]);

		if (! moz2chAbone.shouldAbone(ary[0], ary[1], ary[2], ary[3])){ // name, mail, id, msg
			html[i] = this.old_html[i];
			this.aboneRes[i] = 0;
		}else{
		    html[i] = "";
			this.aboneRes[i] = 1;
		}
		this.old_html[i] = this.old_html[i].replace('<b class="new">New!</b>', "");
	    }
	}else{
	    html = new Array(lines.length - 1);
		var old_aboneRes = new Array(lines.length - 1);
		old_aboneRes = this.aboneRes.clone();
		this.aboneRes = new Array(lines.length - 1);
	    html[0] = this.htmlHeader;
	    html[0] = html[0].replace(/<THREADNAME\/>/g, this.title);

	    html[0] += this.old_html[0];

	    var start = ( lines.length - moz2ch.sureCount > 1)? lines.length - moz2ch.sureCount : 1;
	    for (var i = start; i < (lines.length-sabun_lines.length); i++) {
			if(old_aboneRes[i] == 0){
				html[i] = this.old_html[i];
				this.aboneRes[i] = 0
			}else{
				html[i] = "";
				this.aboneRes[i] = 1
			}
	    }
	    
	    for (var i = (lines.length-sabun_lines.length); i < (lines.length - 1); i++){
		var ary = lines[i].split(delimiter);
		if (ary.length < 2){
		    delimiter=",";
		    ary=ary[0].split(delimiter);
		}
		if (ary.length < 2) break;

	    ary[2] = this.beIdLink(ary[2]);
	    if(abone_array != 0)
		ary[3] = moz2chAbone.linkCheck(ary[3]);
	    this.old_html[i] = this.parseRes(i + 1, ary[0], ary[1], ary[2], ary[3]);

		if (! moz2chAbone.shouldAbone(ary[0], ary[1], ary[2], ary[3])){ // name, mail, id, msg
		    html[i] = this.old_html[i]
			this.aboneRes[i] = 0;
		}else{
		    html[i] = "";
			this.aboneRes[i] = 1;
		}
		this.old_html[i] = this.old_html[i].replace('<b class="new">New!</b>', "");
	    }
	}

	html = html.join(" ");
	html += this.htmlFooter;
	html = html.replace(reg_getres, this.ita.getAttribute(this.datID + ".dat", "sureAcq"))
	           .replace(reg_newres, lines.length - 1 - this.ita.getAttribute(this.datID + ".dat", "sureAcq"))
	           .replace(reg_allres, lines.length - 1)
	           .replace(reg_sureurl, this.url.replace(/\/l50/g, ".dat"));
	
	return html;
};

moz2ch2chSure.prototype.beIdLink =
function (id) {
    try{
	if(id.match("BE:")){
	    id = id.replace(/BE:([0-9]+)-([\S\s]*)/g,'BE:<a href="http://be.2ch.net/test/p.php?i=$1&u=d:<SUREURL>" target="_blank">$1</a>-$2').replace(/<SUREURL>/g, this.url);
	}
    }catch(e){ moz2ch.debug(e); }
    return id;
};
