/* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * <pre lang="ja">
 * (_(    
 * ( `)   Yahooĥ饹ʡ
 * (      )     : 2004/06/11
 *      񤤤  : ؤ41
 * (___)__)   Ď؎ˎގ:
 *            
 * </pre>
 */

function moz2chYahooIta(itaTree, title, url) {
    this.base = moz2chIta;
    this.base(itaTree, title, url);

    this.bbsId = "yahoo";
    
    this.itaTree = itaTree;
    //http://messages.yahoo.co.jp/bbs?action=topics&board=1835546&sid=1835546&type=r
    var a = this.url.split("/");
    this.sabaID = a.splice(2,1).join("/");
    var tmp = a.pop(); // pop query string
    tmp = tmp.split("&");
    this.itaID = tmp[1].split("=")[1];
}

/////////////////////////
// extends moz2chTreeData
moz2chYahooIta.prototype = new moz2chIta();

moz2chYahooIta.prototype.itaLeaf = "index.html";

/////////////////////////////////
// title/log/download information

//moz2chYahooIta.prototype.logPath = null;
moz2chYahooIta.prototype.getLogPath =
function () {
    if (!this.logPath) {
        var logFile = new Dir(this.getBBSDir());

        logFile.append(this.itaID);
        if (!logFile.exists())
            logFile.create(kMoz2chDataDirPerm);
        logFile.append(this.itaLeaf);
        this.logPath = logFile.path;
    }
    return this.logPath;
};

moz2chYahooIta.prototype.getDataURL =
function () {
    return this.url;
};

moz2chYahooIta.prototype.getSureURL =
function (sureId) {
    var rv = 0;
    var row;
    for (var i = 0; i < this.sureRowSet.length; i++) {
        if (sureId == this.sureRowSet[i].sureId) {
            row = this.sureRowSet[i];
            break;
        }
    }

    if ( ! row ) return;
    //http://messages.yahoo.co.jp/bbs?.mm=GN&action=m&board=1835555&tid=bfbf6ua4o5db0za49a4k&sid=1835555&mid=1&type=date&first=1
    return "http://" + this.sabaID + "/bbs?.mm=GN&action=m&board=" + row.board + "&tid=" + row.tid 
           + "&sid=" + row.sid + "&mid=1&type=date&first=1";
};

/////////////////
// parse the data

moz2chYahooIta.prototype.dataConvert =
function () {
    var data = moz2chCharset.euc2uni(this.itadata);

	return data;
};

moz2chYahooIta.prototype.mainParse =
function () {
    var blocks = data.split("<table");
    
    var resReg = new RegExp().compile("<tr>.*<a href=\".*board=(.*)&tid=(.*)&sid=(.*)&mid.*\">(.*)</a></td>\n<td width.*nowrap>(.*)</td><td.*<td.*nowrap>(.*)</td>");
    var resNum = 1;
    for (var i = 0; i < blocks.length; i++) {
       if ( blocks[i].match("<a href=\"/bbs")) {
           var lines = blocks[i].split("</tr>");
           for ( var j=0; j<lines.length; j++ ) {
               if (lines[j].match("<tr>.*<a href=\"/bbs.*</a></td>") ) {
                   var rv = resReg.exec(lines[j]);
                   if ( rv ) {
                       //num, name, res, board, tid, sid, lastModified
                       this.addSure(resNum, rv[4], rv[5], rv[1], rv[2], rv[3], rv[6]);
                       resNum++;
                   }
               }

           }
       }
    }
};

///////////////////
// read/write index
moz2chYahooIta.prototype.readIndex =
function () {
    var f = new File(this.getIndexPath());
    if (!f.exists())
        return false;

    f.open("r");
    var index = f.read();
    f.close();
    index = moz2chCharset.sjis2uni(index);
    index = index.split("\r\n");
    this.clear();
    for (var i = 0; i < index.length; i++) {
        var line = index[i].split(",");
        if (line.length < 5)
            break;

        var name = line[1].replace(/\\c/g, ",");
        name = name.replace(/\\\\/g, "\\");
        var lm = line[7].replace(/\\c/g, ",");
        lm = lm.replace(/\\\\/g, "\\");
      
        var row = {
            sureNum: line[0],
            sureName: name,
            sureRes: line[2],
            sureAcq: line[3],
            board: line[4],
            tid: line[5],
            sid: line[6],
            lastModified: lm,
            sureAttr: (line[8] || "LOADED"),
            surePos: (line[9] || 0),
	    sureNew: null,
            get sureId () {
                return this.tid;
            },
        }
        this.sureRowSet.push(row);
    }
    // read index succeeded
    return true;
};

moz2chYahooIta.prototype.writeIndex =
function () {
    var table = [];
    for (var i = 0; i < this.sureRowSet.length; i++) {
        var name = this.sureRowSet[i].sureName.replace(/\\/g, "\\\\");
        name = name.replace(/,/g, "\\c");
        var lm = this.sureRowSet[i].lastModified || "";
        lm = lm.replace(/\\/g, "\\\\");
        lm = lm.replace(/,/g, "\\c");
        table[this.sureRowSet[i].sureNum -1] = this.sureRowSet[i].sureNum + "," + name + "," + this.sureRowSet[i].sureRes
                + "," + this.sureRowSet[i].sureAcq + "," + this.sureRowSet[i].board + "," + this.sureRowSet[i].tid + "," + this.sureRowSet[i].sid
                + "," + lm + "," + this.sureRowSet[i].sureAttr + "," + this.sureRowSet[i].surePos;
    }
    var index = table.join("\r\n") + "\r\n";
    if (index.length > 0) {
        index = moz2chCharset.uni2sjis(index);
        var f = new File(this.getIndexPath());
        f.open("w", 0644);
        f.write(index);
        f.close();
    }
};

moz2chYahooIta.prototype.addSure =
function (num, name, res, board, tid, sid, lastModified) {
     var row = {
        sureNum: num,
        sureName: name,
        sureRes: res,
        sureAcq: 0,
        board: board,
        tid: tid,
        sid: sid,
        lastModified: lastModified,
        sureAttr: "NEW",
        surePos: 0,
	sureNew: null,
        get sureId () {
            return this.tid;
        },
    }
    this.sureRowSet.push(row);
};

moz2chYahooIta.prototype.sortSureRowSet = 
function ( key, direct ) {

};
