/* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * <pre lang="ja">
 * (_(    
 * ( `)   Yahooĥĥ꡼饹ʡ
 * (      )     : 2004/06/04
 *      񤤤  : ؤ41
 * (___)__)   Ď؎ˎގ: 
 *                        
 *            
 * </pre>
 */

include("chrome://moz2ch/content/data.js");
include("chrome://moz2ch/content/treeData.js");

function moz2chYahooItaTree(title, url) {

    this.base = moz2chItaTree;
    this.base(title, url);
   	this.url = "http://messages.yahoo.co.jp/index.html";
    this.getTitle =  function () {
        return moz2chCharset.euc2uni("Yahoo!");
    };

    this.bbsId = "yahoo";
    this.rdfRootURI= "http://www.yahoo.co.jp/";

    // Moz2chǥ쥯ȥꥲȡ
    var moz2chDir = kDirectoryService
            .get("ProfD", Components.interfaces.nsIFile);
    moz2chDir.append(kMoz2chDirName);

    if (!moz2chDir.exists())
        moz2chDir.create(moz2chDir.DIRECTORY_TYPE, 0700);

    var file = moz2chDir.clone();
    file.append("bbs");
    file.append(this.bbsId);
    file.append(kMoz2chRDFName);
    file = kIOService.newFileURI(file).spec;

    // ǡ򥻥ơ
    var ds = kRDFService.GetDataSourceBlocking(file); 
    this.datasource = ds;
   
    // RDFκǤäȤ
    var res = kRDFService.GetResource( this.rdfRootURI ); 
    this.rdfRoot = kRDFContainerUtils.MakeSeq(this.datasource, res);
}

///////////
// 
const kmoz2chItaTreeLeaf = "index.html";

/////////////////////////
// extends moz2chTreeData
moz2chYahooItaTree.prototype = new moz2chItaTree();


moz2chYahooItaTree.prototype.get = 
function() {
    this.clear();
    this.subloader.itaTree = this;
    this.subloader.targetURL = this.url;
    this.subloader.get();

}

moz2chYahooItaTree.prototype.subloader = {
    itaTree: null,
    targetURL: null,
    targetCategory: null,
    categoryStack: [],
    ioService: Components.classes["@mozilla.org/network/io-service;1"]
            .getService(Components.interfaces.nsIIOService),
    uri: Components.classes["@mozilla.org/network/standard-url;1"]
            .createInstance(Components.interfaces.nsIURI),
    bStream: Components.classes["@mozilla.org/binaryinputstream;1"]
                .createInstance(Components.interfaces.nsIBinaryInputStream),
    get: function () {
        // initialize data
        this.data = "";
		this.uri.spec = this.targetURL;
		moz2ch.debug(this.uri.spec);
        //if (!this.channel) {
            this.channel = this.ioService.newChannelFromURI(this.uri)
                    .QueryInterface(Components.interfaces.nsIHttpChannel);
            // Monazilla UA
            this.channel.setRequestHeader("User-Agent", moz2ch.ua, false);
            // load bypass cache(strong reload)
            this.channel.loadFlags =
                    Components.interfaces.nsIRequest.LOAD_BYPASS_CACHE;
        //}
        moz2ch.debug("moz2chData.get: dataURL=" + this.targetURL);
        moz2ch.debug("moz2chData.get: loadFlags=" + this.channel.loadFlags);
        // arg 3 is invalid? needs to be reconsidered!
        this.channel.asyncOpen(this, this, 0);
    },

    ///////////////////////////////
    // implements nsIStreamListener
    onDataAvailable: function (request, ctxt, input, offset, count) {
        this.bStream.setInputStream(input);
        var str = this.bStream.readBytes(count);
        str = str.replace(/\x00/g, "*");
        this.data += str;
    },

    ////////////////////////////////
    // implements nsIRequestObserver
    onStartRequest: function (request, ctxt) {},
    onStopRequest: function (request, ctxt, status) {
        try {
            var data = this;
            function asyncParse() {
try{
                data.parse();

                if ( data.hasNext() ) {
                    data.get();
                } else {
                    data.itaTree.datasource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush();
                }

}catch(e){
     moz2ch.debug(e);
}
            }
            setTimeout(asyncParse, 0);
        } catch (e) {
            moz2ch.debug("moz2chData.onStopRequest: " + e);
        }
    },

    hasNext: function () {
        function headCat( stack ) {
            var a = stack[stack.length - 1];
            if ( (!a) || a.length < 1 ) {
                stack.pop();
                if ( stack.length > 0 )
                    headCat( stack );
            }
        }

        headCat( this.categoryStack );
        if ( this.categoryStack.length < 1 ) return false;
       
        var array = this.categoryStack[this.categoryStack.length - 1];
        var obj =  array.shift();
        if ( obj ) {
            this.targetURL = obj.url;
            this.targetCategory = obj.catObj;
        }
       
        return true;
    },

    parse: function() {
        //Top PageΎʎގԎ

        var data = moz2chCharset.euc2uni(this.data);
		moz2ch.debug(data);

        if ( this.targetURL == this.itaTree.url ) {
            var data = moz2chCharset.euc2uni(this.data);

            var blocks = data.split(/<table/gi);
            for ( var i=0; i<blocks.length; i++ ) {
                //Ǽİ֥åΎʎ
                if (blocks[i].match("<small><b>")) {
                    var lines = blocks[i].split("\n");
                    var array = [];
                    this.categoryStack.push(array);

                    for ( var j=0; j<lines.length; j++ ) {
                        if ( lines[j].match(/<small><b>/)){
                            var urlandcat = lines[j].replace(/.*<a href=\"(.*)\"><small><b>(.*)<\/b>.*/, "http://messages.yahoo.co.jp/$1\t$2").split("\t");
                            var cat = this.itaTree.addCategory(urlandcat[1]);
try{
                            var obj = {
                                url: urlandcat[0],
                                name: urlandcat[1],
                                catObj: cat,
                            }                            
                            array.push(obj);
}catch(e){
moz2ch.debug(e);
}
                        }
                    }
                    break;
                }
            }
        } else {
            var blocks = data.split(/<table/gi);
            for ( var i=0; i<blocks.length; i++ ) {
                //ǥ쥯ȥ֥åΎʎ
                if (blocks[i].match("<a href=/yahoo.*><b>")) {
                    var lines = blocks[i].split("\n");
                    var array = [];
                    this.categoryStack.push(array);
                    for ( var j=0; j<lines.length; j++ ) {
                        if ( lines[j].match(/<a href=\/yahoo/)){
                            var urlandcat = lines[j].replace(/.*<a href=(.*)><b><small>(.*)<\/small><\/b><\/a>/, "http://messages.yahoo.co.jp$1\t$2").split("\t");
                            if ( ! urlandcat[1].match(".*@$")) {
                                var cat = this.itaTree.addCategory(urlandcat[1], this.targetCategory);
                                var obj = {
                                    url: urlandcat[0],
                                    name: urlandcat[1],
                                    catObj: cat,
                                }
                                array.push(obj);
                            }
                        }
                    }
                }
                if ( blocks[i].match("<tr><td><a href=/bbs?")) {
                    //;פʹԤΎގ
                    blocks[i] = blocks[i].split("\n")[0];
                    var subblocks = blocks[i].split("<td>");
                    for ( var j=0; j<subblocks.length; j++ ) {
                        if ( subblocks[j].match("<a href=\/bbs?")){                       
                            var urlandita = subblocks[j].replace(/.*<a href=(.*)>(.*)<\/a>.*/, "$1\t$2").split("\t");
                            if ( ! urlandita[1].match(".*@$")) {
                                this.itaTree.addIta(this.targetCategory.container, urlandita[1], 
									"http://messages.yahoo.co.jp"  + urlandita[0], this.itaTree.bbsId);
                            }
                        }
                    }
                }
            }
          
        }

    },
}


moz2chYahooItaTree.prototype.getTitle =
function () {
    return this.title;
};

moz2chYahooItaTree.prototype.logPath = null;
moz2chYahooItaTree.prototype.getLogPath =
function () {
    if (!this.logPath) {
        var f = new Dir(this.getBBSDir());
        f.append(this.bbsId);
        f.append(kMoz2chItaTreeLeaf);
        this.logPath = f.path;
    }
    return this.logPath;
};

moz2chYahooItaTree.prototype.getDataURL =
function () {
    return this.url;
};



/**
 * ĥ꡼Ǥ!
 */
moz2chYahooItaTree.prototype.clear =
function () {
    // clear selection

    function clearTree( ds, parent, childs ) {
        try{
        while (childs.hasMoreElements()) {
            var res = childs.getNext();
            if ( kRDFContainerUtils.IsContainer( ds, res )) {
                var node = kRDFContainerUtils.MakeSeq(ds, res);
                clearTree( ds, node, node.GetElements() );
            } 
            
            parent.RemoveElement( res, false );
            var arcs = ds.ArcLabelsOut( res );
            while( arcs.hasMoreElements()) {
                var arc = arcs.getNext();
                var targets = ds.GetTargets( res, arc, true );
                while( targets.hasMoreElements() ) {
                    var target = targets.getNext();
                    ds.Unassert(res, arc, target, true);
                }
            }
        }
        }catch(e){
            moz2ch.debug("clearTree Error " + e);
        }
    }

    clearTree( this.datasource, this.rdfRoot, this.rdfRoot.GetElements());
    this.datasource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush();
};

/**
 * ƥɲä
 *
 * @param aTitle ƥΥȥ
 * @return ɲä줿ƥnsIRDFContainer
 */
moz2chYahooItaTree.prototype.addCategory =
function (aTitle, aParentCat) {
try{
    var catObj = {};
    var cont;
   
    catObj.res = kRDFService.GetAnonymousResource();
   
    var container = Components.classes["@mozilla.org/rdf/container;1"]
            .getService(Components.interfaces.nsIRDFContainer);
    if ( aParentCat ) {
        container.Init( this.datasource, aParentCat.res ); 
        cont = aParentCat.container;
    } else {
        container.Init( this.datasource, kRDFService.GetResource( this.rdfRootURI ));
        cont = this.rdfRoot; 
    }

    catObj.container = kRDFContainerUtils.MakeSeq(this.datasource, catObj.res);
    this.datasource.Assert(catObj.res, kMoz2chItaTreeTitleRes,
            kRDFService.GetLiteral(aTitle), true);

    cont.AppendElement(catObj.res);
}catch(e){
    moz2ch.debug(e);
}
    return catObj;
};

/**
 * Ĥɲä
 * 
 * @param aCategory ƥnsIRDFContainer
 * @param aTitle    ĤΥȥ
 * @param aUrl      ĤURL
 * @param aType     Ĥμ(ά"2ch")
 */
moz2chYahooItaTree.prototype.addIta =
function (aCategory, aTitle, aUrl, aType) {
    if (!aType)
        aType = this.bbsId;

    var res = kRDFService.GetAnonymousResource();

    this.datasource.Assert(res, kMoz2chItaTreeTitleRes,
            kRDFService.GetLiteral(aTitle), true);
    this.datasource.Assert(res, kMoz2chItaTreeURLRes, 
            kRDFService.GetLiteral(aUrl), true);
    this.datasource.Assert(res, kMoz2chItaTreeTypeRes,
            kRDFService.GetLiteral(aType), true);
    aCategory.AppendElement(res);
};

