/* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * <pre lang="ja">
 * (_(    
 * ( `)   ǡ饹ʡ
 * (      )     : 2004/11/13
 *      񤤤  : ˼⤸顼
 * (___)__)   ȥӥݥ: ؤ41
 *                        tRZ80FPU5k
 *            BBSǥ쥯ȥ᥽åɤɲå
 *            
 *
 * subclassϤĤŬ˼
 *    String getDataURL();    ǡURL
 *    String getLogPath();    եѥ(ʤк)֤
 *    String getTitle();      ɽѥȥ֤
 *    bool parse();           ǡΥѡ
 *    
 *    void onRequest();       ꥯȻν(ʬgetʤ)
 *
 *    void unload();          ǡν񤭽Ф
 *    void getBBSDir();       bbsѥ롼ȥǥ쥯ȥμ
 * </pre>
 */

// JSLib
include("chrome://jslib/content/io/file.js");
include("chrome://jslib/content/io/dir.js");
include("chrome://jslib/content/io/dirUtils.js");

const kMoz2chDataDirName = "Moz2ch";
const kMoz2chDataDirPerm = 0755;
const kMoz2chDataFilePerm = 0644;

function moz2chData(title, url) {
    this.title = title;
    this.url = url;
    this.stopFlag = 0;
    this.dataLoadedListener = new Array();    //moz2chData.loaded()ǸƤ֥ꥹʡ
    try {
        this.bStream = Components.classes["@mozilla.org/binaryinputstream;1"]
                .createInstance(Components.interfaces.nsIBinaryInputStream);
    } catch (e) {}
}

moz2chData.prototype = {
    ///////////////////////
    // moz2chData variables

    // XPCOM objects
    ioService: Components.classes["@mozilla.org/network/io-service;1"]
            .getService(Components.interfaces.nsIIOService),
    uri: Components.classes["@mozilla.org/network/standard-url;1"]
            .createInstance(Components.interfaces.nsIURI),
    iStream: Components.classes["@mozilla.org/scriptableinputstream;1"]
            .createInstance(Components.interfaces.nsIScriptableInputStream),

    // nsIHttpChannel channel
    channel: null,
    oldChannel: null,
   
    bbsId: "unknown", //"2ch""yahoo""shitaraba"Ȥˤʤơݥ

    data: "",
	oldData:"",

    stopFlag: null,

    /////////////////
    // loading status
    loading: function () {},
    loaded: function () {
	moz2ch.status();
	if(this == moz2ch.sureView.data){
	    moz2ch.defaultStatus(moz2ch.getString("endparse"));
	}else{
	    moz2ch.defaultStatus(moz2ch.getString("defaultStatus"));
	}
    },
    
    unload: function() {},

    reload: function () {
		try{
		this.stop();
		this.unload();

        moz2ch.setBusy(true);
        this.get();
        moz2ch.setBusy(false);
	}catch(e){ moz2ch.debug(e); }
    },

    stop: function () {
        if (this.channel && this.channel.isPending()) {
            moz2ch.debug("moz2chData.stop: stop loading data " + this.title);
            this.channel.cancel(Components.interfaces.nsIRequest.NS_BINDING_ABORTED);
            moz2ch.setBusy(false);
	    this.oldChannel = this.channel;
	    this.channel = null;
	    this.stopFlag = 1;
		this.data = this.oldData;
        }
    },

    /////////////////////////
    // download functionality

    // start download
    get: function () {
        // initialize data
        this.oldData = this.data;
        this.data = "";

        this.uri.spec = this.getDataURL();
        this.channel = this.ioService.newChannelFromURI(this.uri)
                .QueryInterface(Components.interfaces.nsIHttpChannel);
        // Monazilla UA
        this.channel.setRequestHeader("User-Agent", moz2ch.ua, false);
        // load bypass cache(strong reload)
        this.channel.loadFlags =
                Components.interfaces.nsIRequest.LOAD_BYPASS_CACHE;
        moz2ch.debug("moz2chData.get: dataURL=" + this.getDataURL());
        moz2ch.debug("moz2chData.get: loadFlags=" + this.channel.loadFlags);
        this.onRequest();
        moz2ch.status(moz2ch.getString("checkdata"));
        // arg 3 is invalid? needs to be reconsidered!
        this.channel.asyncOpen(this, this, 0);
    },

    onRequest: function (channel) {},

    // process by the value of responseStatus
    onResponse: function (resStat) {
        switch (resStat) {
        case 200: // OK
            if(this.stopFlag == 1){
                moz2ch.setBusy(false);
                this.stopFlag = 0;
                break;
            }
            this.onGet();
            break;
        default:
            moz2ch.status(moz2ch.getString("onerror"));
            this.onError();
            break;
        }
    },

    // data handler
    onGet: function () {
        try{
        var rv = this.parse();
        
        this.loaded();
        
        if (rv && this.data.length > 0) {
            // if parse succeeded, save the data.
            var f = new File(this.getLogPath());
            f.open("w", kMoz2chDataFilePerm);
            f.write(this.data);
            f.close();
        }
        }catch(e){ moz2ch.debug(e); }
    },

    // error handler
    onError: function () {
        // if error, then read log if it exists.
        moz2ch.debug("moz2chData.onError: Failed to get, Reading log...");
        if (!this.readLog())
            this.errorMsg();
	moz2ch.status(moz2ch.getString("onerror"));
    },  
    errorMsg: function () {
        var msg = moz2ch.getString("dataDownloadError");
        msg = msg.replace("@url@", this.getDataURL());
        alert(msg);
    },

    ////////////////////
    // log functionality
    deleteLog: function () {
        var f = new File(this.getLogPath());
        if (!f.exists())
            return false;
        try {
            moz2ch.debug("moz2chData.deleteLog: " + this.getLogPath());
            f.remove();
        } catch (e) {
            moz2ch.debug("moz2chData.deleteLog: can't remove the file: "
                    + this.getLogPath());
        }
    },
    readLog: function () {
        var f = new File(this.getLogPath());
        if (!f.exists())
            return false;
        this.loading();
        f.open("r");
        this.data = f.read();
	if(this == moz2ch.sureView.data){
	    var temp = this.data.split("\n");
	    if(temp.pop() != ""){
		this.data = this.data + "\n";
	    }
	}
        f.close();
        this.parse();
        this.loaded();
	if(this == moz2ch.sureView.data){
	    if(this.ita.getAttribute(this.datID + ".dat", "sureNew")){
		this.ita.setAttribute(this.datID + ".dat", "sureNew", null);
	    }
	}
        return true;
    },
	logTest: function()
	{
		var f = new File(this.getLogPath());
        if (!f.exists())
            return false;
		return true;
	},

    // utility method
    moz2chDir: null,
    getMoz2chDir: function () {
        if (!this.moz2chDir) {
            var dirUtils = new DirUtils();
            var dir = new Dir(dirUtils.getMozUserHomeDir());
            dir.append(kMoz2chDataDirName);
            if (!dir.exists())
                dir.create(kMoz2chDataDirPerm);
            this.moz2chDir = dir.path;
        }
        return this.moz2chDir;
    },

    getBBSDir: function () {
        if (!this.bbsDir) {
            var dir = new Dir(this.getMoz2chDir());
            dir.append("bbs");
            dir.append(this.bbsId);
            if (!dir.exists())
                dir.create(kMoz2chDataDirPerm);
            this.bbsDir = dir.path;
        }
        return this.bbsDir;
    },

    ///////////////////////////////
    // implements nsIStreamListener
    onDataAvailable: function (request, ctxt, input, offset, count) {
        if (!this.bStream) {
            this.iStream.init(input);
            this.data += this.iStream.read(count);
            return;
        }

        /*
            trunkbug 170585fix (ϡ)!!!!
        */
        this.bStream.setInputStream(input);
        var str = this.bStream.readBytes(count);
        str = str.replace(/\x00/g, "*");
        this.data += str;
    },
    
    ////////////////////////////////
    // implements nsIRequestObserver
    onStartRequest: function (request, ctxt) {},
    onStopRequest: function (request, ctxt, status) {
        var resStat;
        try {   // output responseStatus/responseStatusText
	    if(this.oldChannel){
		//resStat = this.oldChannel.responseStatus;
		//moz2ch.debug(resStat + " " + this.oldChannel.responseStatusText);
		this.oldChannel = null;
		return;
	    }else if (this.channel){
		resStat = this.channel.responseStatus;
		moz2ch.debug(resStat + " " + this.channel.responseStatusText);
	    }else{
			moz2ch.debug("Stopped by unexpected Error");
		}
        } catch (e) {
            moz2ch.debug(e);
            if (0 != status) {
                // request error! call onError
                moz2ch.debug("requestStatus: " + status);
                this.onError();
                return;
            }
        }
        
        try {
            this.onResponse(resStat);
        } catch (e) {
            moz2ch.debug("moz2chData.onStopRequest: " + e);
        }
    },

    addDataLoadedListener: function( listener ) {
        this.dataLoadedListener.push( listener );
    },
};

function NOIMPL() {
    alert(arguments.caller + "is not implemented!!");
}
