/* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * <pre lang="ja">
 * (_(    
 * ( `)   ĥĥ꡼饹ʡ
 * (      )     : 2004/05/29
 *      񤤤  : ˼⤸顼
 * (___)__)   Ď؎ˎގ: ؤ41
 *                        ĥĥ꡼μѹǤ褦ˤ
 *            
 * </pre>
 */

/////////////////////////////////////////////////////
// դΥХXPCOM singleton ϤޤȤ٤

/////////////////
// RDF Components
const kRDFService = Components.classes["@mozilla.org/rdf/rdf-service;1"]
        .getService(Components.interfaces.nsIRDFService);
const kRDFContainerUtils =
        Components.classes["@mozilla.org/rdf/container-utils;1"]
        .getService(Components.interfaces.nsIRDFContainerUtils);

////////////////////
// Directory Service
const kDirectoryService =
        Components.classes["@mozilla.org/file/directory_service;1"]
        .getService(Components.interfaces.nsIProperties);

/////////////
// IO Service
const kIOService = Components.classes["@mozilla.org/network/io-service;1"]
        .getService(Components.interfaces.nsIIOService);

///////////
// 
const kMoz2chNS = "http://moz2ch.sourceforge.jp/index.rdf#";
const kMoz2chItaTreeViewRootURI = "http://www.2ch.net/";
const kMoz2chDirName = "Moz2ch";
const kMoz2chRDFName = "index.rdf";

const kMoz2chItaTreeTitleRes = 
        kRDFService.GetResource(kMoz2chNS + "title");
const kMoz2chItaTreeURLRes =
        kRDFService.GetResource(kMoz2chNS + "url");
const kMoz2chItaTreeTypeRes =
        kRDFService.GetResource(kMoz2chNS + "type");

function moz2chItaTree(title, url) {
    this.base = moz2chTreeData;
    this.base(title, url);
}

///////////
// 
const kMoz2chItaTreeLeaf = "bbsmenu.html";

moz2chItaTree.prototype.changeDat = new Array();
moz2chItaTree.prototype.changeDat_Old = new Array();
moz2chItaTree.prototype.datasource = null;

/////////////////////////
// extends moz2chTreeData
moz2chItaTree.prototype = new moz2chTreeData();

moz2chItaTree.prototype.getTitle =
function () {
    return this.title;
};

moz2chItaTree.prototype.logPath = null;
moz2chItaTree.prototype.getLogPath =
function () {
    if (!this.logPath) {
        var f = new Dir(this.getMoz2chDir());
        f.append(kMoz2chItaTreeLeaf);
        this.logPath = f.path;
    }
    return this.logPath;
};

moz2chItaTree.prototype.getDataURL =
function () {
    return this.url;
};

/**
 * bbsmenu.htmlѡ
 * @return true
 */
moz2chItaTree.prototype.dataConvert =
function () {
    var data = moz2chCharset.sjis2uni(this.data);

	return data;
};

moz2chItaTree.prototype.parse =
function () {
    this.clear();

    // sjis -> unicode
    var data = this.dataConvert();

	this.mainParse(data);

    // parse succeeded
    return true;
};

moz2chItaTree.prototype.mainParse =
function (data) {
    var blocks = data.split(/<br><br>/gi);
    var categoryRe = /<b>([^<]+?)<\/b>/i;
    var urlRe = /(http:\/\/[^>]+\/).*?>([^<]+?)<\/a>/gi;

    // to remove needless blocks, write -3
    for (var i = 1; i < blocks.length - 3; i++) {
        var ret = categoryRe.exec(blocks[i]);
        var category = this.addCategory(ret[1]);
        var j = 1;
        do {
            var ret = new Array();
            ret = urlRe.exec(blocks[i]);
            if (ret)
                this.addIta(category, ret[2], ret[1]);
        } while (ret);
    }

    // external ita tree file
    this.readOtherBrd();

    this.datasource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush();
};

/**
 * ĥ꡼Ǥ!
 */
moz2chItaTree.prototype.clear =
function () {
    // clear selection
   
    function clearTree( ds, parent, childs ) {
        try{
        while (childs.hasMoreElements()) {
            var res = childs.getNext();
            if ( kRDFContainerUtils.IsContainer( ds, res )) {
                var node = kRDFContainerUtils.MakeSeq(ds, res);
                clearTree( ds, node, node.GetElements() );
            } 
            
            parent.RemoveElement( res, false );
            var arcs = ds.ArcLabelsOut( res );
            while( arcs.hasMoreElements()) {
                var arc = arcs.getNext();
                var targets = ds.GetTargets( res, arc, true );
                while( targets.hasMoreElements() ) {
                    var target = targets.getNext();
                    ds.Unassert(res, arc, target, true);
                }
            }
        }
        }catch(e){
            moz2ch.debug("clearTree Error " + e);
        }
    }

    clearTree( this.datasource, this.rdfRoot, this.rdfRoot.GetElements());
    this.datasource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush();
};

/**
 * ƥɲä
 *
 * @param aTitle ƥΥȥ
 * @return ɲä줿ƥnsIRDFContainer
 */
moz2chItaTree.prototype.addCategory =
function (aTitle) {
    var res = kRDFService.GetResource(
            "uri:category" + this.rdfRoot.GetCount()); 
    var category = kRDFContainerUtils.MakeSeq(this.datasource, res);
    this.datasource.Assert(res, kMoz2chItaTreeTitleRes,
            kRDFService.GetLiteral(aTitle), true);

    this.rdfRoot.AppendElement(res);
    return category;
};

/**
 * Ĥɲä
 * 
 * @param aCategory ƥnsIRDFContainer
 * @param aTitle    ĤΥȥ
 * @param aUrl      ĤURL
 * @param aType     Ĥμ(ά"2ch")
 */
moz2chItaTree.prototype.addIta =
function (aCategory, aTitle, aUrl, aType) {
    if (!aType)
        aType = "2ch";

    var res = kRDFService.GetResource(aCategory.Resource.Value + ":item" +
            aCategory.GetCount());
    this.datasource.Assert(res, kMoz2chItaTreeTitleRes,
            kRDFService.GetLiteral(aTitle), true);
    this.datasource.Assert(res, kMoz2chItaTreeURLRes, 
            kRDFService.GetLiteral(aUrl), true);
    this.datasource.Assert(res, kMoz2chItaTreeTypeRes,
            kRDFService.GetLiteral(aType), true);
    aCategory.AppendElement(res);
};

/**
 * Ĥɤ߹ࡣ
 * Ĥ<profile>/Moz2ch/other.brd2channel.brdǳǼ롣
 */
moz2chItaTree.prototype.itaTreeOtherBrd = "other.brd";
moz2chItaTree.prototype.readOtherBrd =
function () {
	var brd = this.checkExistOtherBrd();

    brd = brd.split("\r\n");
    if (brd.length < 2)
        return;

	this.parseOtherBrd(brd);
};

moz2chItaTree.prototype.checkExistOtherBrd =
function () {
    var f = new File(this.getIndexPath());
    f.leaf = this.itaTreeOtherBrd;
    var path = f.path;
    var f = new File(path);

    var brd;
    if (!f.exists()) {
        brd = moz2ch.getString("defaultOtherBrd");
        f.open("w", 0700);
        f.write(moz2chCharset.uni2sjis(brd));
        f.close();
    } else {
        f.open("r");
        brd = moz2chCharset.sjis2uni(f.read());
        f.close();
    }
	return brd;
};

moz2chItaTree.prototype.parseOtherBrd =
function (brd) {
    var category = null;
    for (var i = 1; i < brd.length; i++) {
        var tokens = brd[i].split("\t");
        if (tokens.length >= 4 && category) {
            // this is ita
            var url = "http://" + tokens[1] + "/" + tokens[2] + "/";
	    this.addIta(category, tokens[3], url);
        } else if (tokens.length >= 2) {
            // this is category
            category = this.addCategory(tokens[0]);
            // category.open = (1 == tokens[0]);
        }
    }
};

moz2chItaTree.prototype.getsabaDat =
function (fname) {
    try{
    var f = new File(this.getMoz2chDir());
    f.append(fname);
    if(f.exists()){
	f.open("r");
	var dat = f.read();
	f.close();
	this.changeDat = moz2chCharset.sjis2uni(dat).split("\r\n");
    }
    }catch(e){ moz2ch.debug(e); }
};

moz2chItaTree.prototype.urltoTitle =
function (url) {
    if(this.changeDat){
	for(var i=0; i<this.changeDat.length; i++){
	    var dat = this.changeDat[i].split(" ");
	    if(dat[0].match(url))
	    return dat[1].replace(/\r\n/g, "");
	}
    }
    return "non match";
};
