/* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * <pre lang="ja">
 * (_(    
 * ( `)   ĥӥ塼֥Ȥʡ
 * (      )     : 2004/11/20
 *      񤤤  : ˼⤸顼
 * (___)__)   ȥӥݥ: ĶAnne
 *                      : ؤ41椵
 *                      : (ϡ)(ϡ) tRZ80FPU5k
 *            ιʹɽѥåפ
 *            
 * </pre>
 */
function moz2chItaView () {
}

moz2chItaView.prototype = new moz2chTreeDataView();

moz2chItaView.prototype.elementId    = "ita";
moz2chItaView.prototype.viewId = "itabox";
moz2chItaView.prototype.splitterId   = "itaSplitter";
moz2chItaView.prototype.toggleMenuId = "showIta";

moz2chItaView.prototype.resetExtract = null;

moz2chItaView.prototype.time_flag = null;
moz2chItaView.prototype.timerId = null;

moz2chItaView.prototype.mouse_scr2cliX = null;
moz2chItaView.prototype.mouse_scr2cliY = null;
moz2chItaView.prototype.mouse_baseX = null;
moz2chItaView.prototype.mouse_baseY = null;

moz2chItaView.prototype.targetSure = null;

moz2chItaView.prototype.baseInit2 = moz2chTreeDataView.prototype.init;
moz2chItaView.prototype.init = 
function() {
    this.baseInit2();
    document.getElementById("showAllIta").setAttribute("checked","true");
    if(nsPreferences.getBoolPref("moz2ch.resetExtract") != null){
	this.resetExtract = nsPreferences.getBoolPref("moz2ch.resetExtract");
    }else{
	this.resetExtract = true;
	nsPreferences.setBoolPref("moz2ch.resetExtract", this.resetExtract);
    }
};

moz2chItaView.prototype.__defineGetter__("data", 
     function () { if ( this.element.selectedTab.ita ) return this.element.selectedTab.ita; });

moz2chItaView.prototype.__defineSetter__("data",
function( data ) {
    this.element.selectedTab.ita = data;
    this.element.setTabTitle(this.element.mCurrentTab);
});

moz2chItaView.prototype.reset =
function () {
    this.element.mCurrentTree.treeBoxObject.view = this;
};

moz2chItaView.prototype.baseReload2
    = moz2chTreeDataView.prototype.reload;
moz2chItaView.prototype.reload =
function( data ){
    if(data){
	this.baseReload2(data);
    }else{
	this.baseReload2();
    }
};

/////////////////////////
// implements nsITreeView
moz2chItaView.prototype.hasNextSibling =
function (rowIndex, afterIndex) {
    return (this.data.sureRowSet[rowIndex].sureNum) ? true : false;
};
moz2chItaView.prototype.getCellText =
function (row, colID) {
    switch(colID.id) {
    case "sureMark":
        return this.data.sureRowSet[row].sureAttr;
    case "sureNum":
        return this.data.sureRowSet[row].sureNum;
    case "sureName":
        return this.data.sureRowSet[row].sureName;
    case "sureRes":
        return this.data.sureRowSet[row].sureRes;
    case "sureDate":
        return this.data.sureRowSet[row].lastModified;
    case "sureAcq":
        return this.data.sureRowSet[row].sureAcq;
    case "sureNew":
        return this.data.sureRowSet[row].sureNew;
    default:
	return "";
    }
};

moz2chItaView.prototype.getCellProperties =
function (row, colID, properties) {
    if (colID == "sureMark" || colID.id == "sureMark") {
        var aserv=Components.classes["@mozilla.org/atom-service;1"].createInstance(Components.interfaces.nsIAtomService);
        properties.AppendElement(aserv.getAtom(this.data.sureRowSet[row].sureAttr));
    }
};

moz2chItaView.prototype.getRowProperties =
function (row, properties) {
    if ((row % 2) == 1) {
        var aserv=Components.classes["@mozilla.org/atom-service;1"].createInstance(Components.interfaces.nsIAtomService);
        properties.AppendElement(aserv.getAtom("ita-ODD"));
    }
};

moz2chItaView.prototype.getRowCount =
function (index) {
    return (this.data && this.data.sureRowSet) ? this.data.sureRowSet.length : 0;
};

//nsFindInstDataǻѤwebBrowserFind
moz2chItaView.prototype.webBrowserFind =
{
    searchString:null,
    matchCase:null,
    wrapFind:null,
    findBackwards:null,
    findNext: function (flag){ 
        try{
            var reg;
            var rowCount = moz2ch.itaView.getRowCount();
            var start;
            var i, cnt;
            var result = false;
	    this.findBackwards = flag;

            this.matchCase ? reg = new RegExp( this.searchString ) : reg = new RegExp( this.searchString, "i");

            (! this.findBackwards) ? (moz2ch.itaView.selection.currentIndex <= 0 ? start = 0 : start = moz2ch.itaView.selection.currentIndex + 1) 
               :	(moz2ch.itaView.selection.currentIndex <= 0 ? start = 0 : start = moz2ch.itaView.selection.currentIndex - 1);
	
            cnt = 0;
            for ( i = start; (! this.findBackwards) ? (i < rowCount) : ( i>= 0) ; (!this.findBackwards) ? i++ : i--, cnt++) {
                if ( reg.test( moz2ch.itaView.data.sureRowSet[i].sureName) ) {
                    moz2ch.itaView.selection.tree.scrollToRow(i);
                    moz2ch.itaView.selection.select(i);
                    cnt = 0;
                    result = true;
                    break;
                }
		
                if ( cnt >= rowCount ) {
                    break;
                }
			
                if ( (! this.findBackwards) && this.wrapFind && (i >= rowCount - 1)) {
                    i = 0;
                } else if ( this.findBackwards && this.wrapFind &&  (i <= 0) ) {
                    i = rowCount - 1;
                }
            }

	        return result;

        }catch(e){
            moz2ch.debug(e);
        }
    }
};

moz2chItaView.prototype.saveCurSurePos = 
function() {
    try{
        var sure = moz2ch.sureView.data;
	if ( ! sure ) return;
	var pos = moz2ch.sureView.getCurScrollPos();
	if(pos)
	sure.ita.setAttribute(sure.sureId, "surePos", pos);
    }catch(e){
	moz2ch.debug("moz2chItaView.saveCursurePos:" + e);
    }
};

moz2chItaView.prototype.sortSureRowSet = 
function( col ) {
    try{
        var direction = col.getAttribute("sortDirection");
	
        if ( ! this.data ) return;
        if ( ! direction ) direction = "ascending";
        this.data.sortSureRowSet( col.id, direction );
        direction == "ascending" ? direction = "descending" : direction = "ascending";
        for ( var i in col.parentNode.getElementsByTagName("treecol") ) {
            try {
                col.parentNode.getElementsByTagName("treecol")[i].removeAttribute("sortDirection");
            }catch(e){}
        }
        col.setAttribute("sortDirection", direction);
        this.reset();
    }catch(e){
        moz2ch.debug(e);
    }
};

moz2chItaView.prototype.find = 
function () {
    try{
        var findInstData = new nsFindInstData();
        findInstData.init = function(){}; //nsFindInstData.init()QueryInterfaceΤoverride
        findInstData.browser = this;
        findInPage(findInstData);
    }catch(e){
        moz2ch.debug(e);
    }
};

moz2chItaView.prototype.findAgain = 
function (flag) {
    try{
	this.webBrowserFind.findNext(flag);
    }catch(e){
        moz2ch.debug(e);
    }
};

moz2chItaView.prototype.createPopup = 
function(aEvent) {
    var popup = document.getElementById("itaPopup");
	if(!this.mouse_scr2cliX && !this.mouse_scr2cliY){
	    this.mouse_baseX = aEvent.clientX;
	    this.mouse_baseY = aEvent.clientY;
	}

    var popupBuilder = {
        add: function( element, label, handler ) {
              var element = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul",
                                                  element);
              element.setAttribute("label", label);
              element.setAttribute("oncommand", handler);
              popup.appendChild(element);
              return element;
        },
    }

    for( var i=popup.childNodes.length-1; i >= 0; i-- ) {
          popup.removeChild(popup.childNodes[i]);
    }
    if ( moz2chItaCheckPos(aEvent.clientX, aEvent.clientY) ) {
      popupBuilder.add("menuitem", moz2ch.getString("itaLoadSure"), "try{ moz2chItaOpenSureURL(this.parentNode.boxObject.x, this.parentNode.boxObject.y, 0); }catch(e){ moz2ch.debug(e); }");
      popupBuilder.add("menuitem", moz2ch.getString("itaLoadSureWithNewTab"), "moz2chItaOpenSureURL(this.parentNode.boxObject.x, this.parentNode.boxObject.y, 1);" );
    } else {
      popupBuilder.add("menuitem", moz2ch.getString("itaAddTab"), "var t =moz2ch.itaView.element.addTab(); moz2ch.itaView.element.selectedTab = t;");
      popupBuilder.add("menuitem", moz2ch.getString("itaCloseTab"), "var t =moz2ch.itaView.element.removeCurrentTab()");
    }
};

moz2chItaView.prototype.popupShown =
function(aEvent)
{
	if(!this.mouse_scr2cliX && !this.mouse_scr2cliY){
	    var popup = document.getElementById("itaPopup");
	    this.mouse_scr2cliX = this.mouse_baseX - popup.boxObject.x;
	    this.mouse_scr2cliY = this.mouse_baseY - popup.boxObject.y;
	}
};

//////////////////////
//  Implement (Moz2ch)DataLoadedListener
moz2chItaView.prototype.itaRenew =
function () {
    this.element.mCurrentTree.treeBoxObject.invalidate();
    this.reset();
}

moz2chItaView.prototype.onDataLoaded = 
function( eventObject ) {
    this.data.loaded();
    if(this.resetExtract == true){
        if(document.getElementById("showAllIta").getAttribute("checked") != "true"){
	    document.getElementById("showAllIta").setAttribute("checked", "true");
	    document.getElementById("showNewIta").removeAttribute("checked");
	    document.getElementById("showAcqIta").removeAttribute("checked");
	    document.getElementById("showFindIta").removeAttribute("checked");
	}
    }
    if ( document.getElementById("showAllIta").getAttribute("checked")) {
	this.data.extractNone();
    } else if ( document.getElementById("showNewIta").getAttribute("checked")) {
	this.data.extractNew();
    } else if ( document.getElementById("showAcqIta").getAttribute("checked")) {
	this.data.extractAcquired();
    } else {
	var box = document.getElementById("extractSureBox");
	this.data.extractPhrase(box.value);
    }
    var l = moz2ch.sureView.element.mTabContainer.childNodes.length;
    for(var i=0; i<l; i++){
	try{
        if(moz2ch.sureView.element.mTabContainer.childNodes[i].sure.ita.title == this.data.title){
	    moz2ch.sureView.element.mTabContainer.childNodes[i].sure.ita = this.data;
        }
	}catch(e){}
    }
    this.itaRenew();
};

moz2chItaView.prototype.logDelete = 
function(){
    if(this.data){
	this.data.deleteLog();
	this.reload();
    }
};

moz2chItaView.prototype.extractSure = 
function( event, mode, opt ) {
    try{
    if ( (! mode) || (mode == "all")) {
        document.getElementById("showAllIta").setAttribute("checked", "true");
        document.getElementById("showNewIta").removeAttribute("checked");
        document.getElementById("showAcqIta").removeAttribute("checked");
	document.getElementById("showFindIta").removeAttribute("checked");
        this.data.extractNone();
        this.data.sortSureRowSet(this.data.nowSortType, this.data.nowSortDirect);
    } else if ( mode == "new" ) {
        document.getElementById("showNewIta").setAttribute("checked", "true");
        document.getElementById("showAllIta").removeAttribute("checked");
        document.getElementById("showAcqIta").removeAttribute("checked");
	document.getElementById("showFindIta").removeAttribute("checked");
        this.data.extractNew();
    } else if ( mode == "acq" ) {
        document.getElementById("showAcqIta").setAttribute("checked", "true");
        document.getElementById("showAllIta").removeAttribute("checked");
        document.getElementById("showNewIta").removeAttribute("checked");
	document.getElementById("showFindIta").removeAttribute("checked");
        this.data.extractAcquired();
    }  else if ( mode == "phrase" ) {
	document.getElementById("showFindIta").setAttribute("checked", "true");
        document.getElementById("showAcqIta").removeAttribute("checked");
        document.getElementById("showAllIta").removeAttribute("checked");
        document.getElementById("showNewIta").removeAttribute("checked");
        if ( ! opt ) {
          document.getElementById("showAllIta").setAttribute("checked", "true");
	  document.getElementById("showFindIta").removeAttribute("checked");
          this.data.extractNone();
        } else {
          this.data.extractPhrase(opt);
        }
    }

    this.itaRenew();
    }catch(e){ moz2ch.debug(e); }
}

moz2chItaView.prototype.load =
function (data) {
    this.baseLoad(data);
    if ( document.getElementById("showAllIta").getAttribute("checked")) {
       this.data.extractNone();
    } else if ( document.getElementById("showNewIta").getAttribute("checked")) {
       this.data.extractNew();
    } else if ( document.getElementById("showAcqIta").getAttribute("checked")) {
       this.data.extractAcquired();
    } else {
       var box = document.getElementById("extractSureBox");
       this.data.extractPhrase(box.value);
    }
    this.selection.clearSelection();
};

/////////////////
// Event Handlers
function moz2chItaReload() {
    moz2ch.itaView.reload();
}

function moz2chItaLogDelete() {
    moz2ch.itaView.logDelete();
}

function moz2chItaSelect() {
	try{
    if(moz2ch.itaView.timerId)
		clearTimeout(moz2ch.itaView.timerId);
    var tree = moz2ch.itaView.element.mCurrentTree;
    moz2ch.itaView.selected = true;
    if ( ! moz2ch.itaView.data.sureRowSet[tree.currentIndex] ) return;
    var dat = moz2ch.itaView.data.sureRowSet[tree.currentIndex].sureId;
    var title = moz2ch.itaView.data.sureRowSet[tree.currentIndex].sureName;
    title = title.replace(/(.*)\s/g,"$1");
    if (moz2ch.itaView.selection.count != 1)
        return;

    if (dat) {
        var url = moz2ch.itaView.data.getSureURL(dat);
        var sure = moz2ch.bbsManager.createSure(moz2ch.itaView.data.bbsId, moz2ch.itaView.data, title, url);
        moz2ch.debug(title + "<" + url + ">");
		var tab = moz2ch.sureView.tabFor(sure);
		if(tab){
	    	try{
				moz2ch.sureView.element.selectedTab = tab;
   			}catch(e){
				moz2ch.debug(e);
			}
		}

		if (moz2ch.sureView.data && moz2ch.sureView.data.channel && 
			moz2ch.sureView.data.channel.isPending()){ return; }
	    if (url && (moz2ch.sureView.data && moz2ch.sureView.data.url == url)){
			sure = null;
		    moz2ch.itaView.saveCurSurePos();
			return;
		}
		var rv = sure.logTest();
        sure.addDataLoadedListener( moz2ch.sureView ); //DataLoaded٥ȥꥹʡ
		if(rv){
			this.targetSure = null;
			if(moz2ch.sureView.data){
				moz2ch.sureView.data.destroy();
				delete moz2ch.sureView.data;
			}
        	moz2ch.sureView.load(sure);
		}else{
			this.targetSure = sure;
			sure = null;
		}
    }
	}catch(e){ moz2ch.debug(e); }
}

function moz2chItaBlur() {
    //moz2ch.itaView.saveCurSurePos();
    moz2ch.itaView.selected = false;
}

function moz2chItaFocus() {
    if (!moz2ch.itaView.selected)
        moz2ch.setCurrent(moz2ch.itaView);
}

function moz2chItaDblClick(event) {
    if (event.button != 0)
        return;

    var row = {};
    var col = {};
    var obj = {};
    moz2ch.itaView.element.mCurrentTree.treeBoxObject.getCellAt(event.clientX, event.clientY, row, col, obj);
    row = row.value;

    if (!( (row >= 0) && col )) 
        return;

    var tree = moz2ch.itaView.element.mCurrentTree;

    moz2ch.itaView.selected = true;
    moz2ch.sureView.load_flag = 0;
	if(this.targetSure != null){
        moz2ch.sureView.load(this.targetSure);
		this.targetSure = null;
	}
    var url = moz2ch.itaView.data.getSureURL(moz2ch.itaView.data.sureRowSet[tree.currentIndex].sureId);
    if (url && (moz2ch.sureView.data && moz2ch.sureView.data.url == url)) {
	moz2ch.debug("moz2chItaDblClick: reload=" + url);
	moz2ch.sureView.reload();
    }
}

function moz2chItaClick( aEvent ) {
	try{
        var row = {};
        var col = {};
        var obj = {};
        moz2ch.itaView.element.mCurrentTree.treeBoxObject.getCellAt(aEvent.clientX, aEvent.clientY, row, col, obj);
        row = row.value;
        if ( (row >= 0) && col && (obj.value == "text" || obj.value == "image" || obj.value == "cell") ) {
            //ߤsureViewǡitaView򤵤줿ǡۤʤϥݥ¸
            var tree = moz2ch.itaView.element.mCurrentTree;
            if ( moz2ch.itaView.data.sureRowSet[tree.currentIndex] && moz2ch.sureView.data ) {
                if ( moz2ch.itaView.data.sureRowSet[tree.currentIndex].sureId != moz2ch.sureView.data.sureId )
                    moz2ch.itaView.saveCurSurePos();
            }
            if ( 0 == aEvent.button ) {
                if ( 1 == aEvent.detail ) {
                    moz2ch.itaView.timerId = setTimeout(moz2chItaSelect, 50);
                } else if ( 2 == aEvent.detail ) {
		    		if(moz2ch.itaView.timerId){
						clearTimeout(moz2ch.itaView.timerId);
					if(!moz2ch.itaView.selected)
						moz2ch.itaView.selected = true;
		    		}
                    moz2chItaDblClick(aEvent);
                }
            } else if ( 2 == aEvent.button ) {
                    //moz2ch.debug("popup");
            }
        }
    } catch (e) {
        moz2ch.debug( "moz2chItaClick Error " + e );
    }
}

function moz2chItaDatDelete()
{
    moz2ch.itaView.data.deleteLogDat();
    moz2ch.itaView.reload();
}

function moz2chItaNonDatDelete()
{
    moz2ch.itaView.data.deleteLogNone();
    moz2ch.itaView.reload();
}

function moz2chItaRecheck()
{
    moz2ch.itaView.data.resetLogDat();
    moz2ch.itaView.reload();
}

function moz2chItaOpenSureURL(mx, my, flag)
{
    try{
	var x = mx + moz2ch.itaView.mouse_scr2cliX;
	var y = my + moz2ch.itaView.mouse_scr2cliY;
	var row = {};
	var col = {};
	var obj = {};
	moz2ch.itaView.element.mCurrentTree.treeBoxObject.getCellAt(x, y, row, col, obj);
	row = row.value;
	if ( (row >= 0) && col && (obj.value == "text" || obj.value == "image" || obj.value == "cell") ) {    
	    var tree = moz2ch.itaView.element.mCurrentTree;
	    moz2ch.itaView.selected = true;
	    if ( ! moz2ch.itaView.data.sureRowSet[tree.currentIndex] ) return;
	    var dat = moz2ch.itaView.data.sureRowSet[tree.currentIndex].sureId;
	    var title = moz2ch.itaView.data.sureRowSet[tree.currentIndex].sureName;
	    title = title.replace(/(.*)\s/g,"$1");
	    if (moz2ch.itaView.selection.count != 1)
			return;
	    if (dat) {
			var url = moz2ch.itaView.data.getSureURL(dat);
			moz2ch.debug(title + "<" + url + ">");
		
	    	var sure = moz2ch.bbsManager.createSure(moz2ch.itaView.data.bbsId, moz2ch.itaView.data, title, url);
			var tab = moz2ch.sureView.tabFor(sure);
			if(tab){
    			try{
					sure = null;
					moz2ch.sureView.element.selectedTab = tab;
				}catch(e){
					moz2ch.debug(e);
				}
			}else{
				if (flag == 1)
				{
					var newTab = moz2ch.sureView.element.addTab("about:blank");
					moz2ch.sureView.element.selectedTab = newTab;
				}
		    	if ( moz2ch.itaView.data.sureRowSet[tree.currentIndex] && moz2ch.sureView.data ) {
					if ( moz2ch.itaView.data.sureRowSet[tree.currentIndex].sureId != moz2ch.sureView.data.sureId ){
			    		moz2ch.itaView.saveCurSurePos();
					}
	    		}
	    		sure.addDataLoadedListener( moz2ch.sureView );
				if(moz2ch.sureView.data){
					moz2ch.sureView.data.destroy();
					delete moz2ch.sureView.data;
				}
	    		moz2ch.sureView.load(sure);
			}
			moz2ch.sureView.reload();
		}
	}
    }catch(e){ moz2ch.debug(e); }
}

function moz2chItaSuretate() {
    try{
        if ( ! moz2ch.itaView.data.kakikoView ) {
            moz2ch.itaView.data.kakikoView = window.openDialog("kakiko.xul", "_blank" , "chrome,all,dialog=no,dependent=yes" , moz2ch.itaView.data, 1 /* SURETATE mode */);
        }
    }catch(e){
        moz2ch.debug("Error! moz2chItaSuretate: " + e + "\n");
    }
}

function moz2chItaLogTest(data) {
}

function moz2chItaCheckPos(x, y) {
	var row = {};
	var col = {};
	var obj = {};
	moz2ch.itaView.element.mCurrentTree.treeBoxObject.getCellAt(x, y, row, col, obj);
	row = row.value;
	if ( (row >= 0) && col && (obj.value == "text" || obj.value == "image" || obj.value == "cell") )
		return true;
	else
		return false;
}
