/* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * <pre lang="ja">
 * (_(    
 * ( `)   ץȥʡ
 * (      )     : 2004/06/13
 *      񤤤  : 12 Z80FPU5k
 * (___)__)   Ď؎ˎގ: ؤ41
 *            MogillaescapeϲѤʤΤǤǼʡ
 *            
 * </pre>
 */

const textToSubURI = Components.classes["@mozilla.org/intl/texttosuburi;1"]
                   .getService(Components.interfaces.nsITextToSubURI);

moz2chEscape = function(charset,str){
  return textToSubURI.ConvertAndEscape(charset,str);
}

function moz2chKakiko () {
    this.dataLoadedListener = new Array()    //moz2chData.loaded()ǸƤ֥ꥹʡ
}

moz2chKakiko.prototype = {
///////////////////////
    // moz2chKakiko variables

    // XPCOM objects
    ioService: Components.classes["@mozilla.org/network/io-service;1"]
            .getService(Components.interfaces.nsIIOService),
			
    
    channel: null,
    uiStream: null,    //Upload InputStream
    dbiStream: null,  //Download InputStream
    htmlRes: null,
    target: null,
    KAKIKO: 0,
    SURETATE: 0,

    bundle: null,
    submit: null,

    setSubmit: function () {
	this.submit = this.getString("submit");
    },

    getString: function (key) {
	if(!this.bundle){
	    this.bundle = document.getElementById("moz2chKakikoBundle");
	}
	try{
	    return this.bundle.getString(key);
	}catch(e){
	    moz2ch.debug(e);
	}
    },

    setRequestHeaders: function () {
        this.channel.setRequestHeader("User-Agent", opener.moz2ch.ua, false);
        this.channel.setRequestHeader("Accept","image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, */*", false);

		this.setReferer();

        this.channel.setRequestHeader("Content-Type","application/x-www-form-urlencoded", false);

		this.setOtherHeaders();
    },
    
	setReferer: function() {
        if(this.SURETATE){
            this.channel.setRequestHeader("Referer","http://" + this.target.sabaID + "/" + this.target.itaID + "/", false);
        }else{
            this.channel.setRequestHeader("Referer","http://" + this.target.sabaID + "/test/read.cgi/" + this.target.itaID + "/" + this.target.datID + "/", false);
        }
	},

	setOtherHeaders: function() {
		 this.channel.setRequestHeader("Accept-Charset","Shift_JIS", true);
	},

    setPostData: function () {
	try{
	    var uChannel = this.channel.QueryInterface(Components.interfaces.nsIUploadChannel);
	    if(!this.submit) this.setSubmit();
	    var sub = this.getEscape();
	    
		postData = this.makePostData(sub);

	    this.uiStream.setData(postData, postData.length);

		uChannel = this.setChannel(uChannel);
	}catch(e){
	    moz2ch.debug(e);
	}
    },

	getEscape: function() {
		return moz2chEscape("Shift_JIS",this.submit);
	},

	makePostData: function (sub) {
	    if(this.KAKIKO){
	        var kakikoDate = this.target.lastAccess;
	        if( ! kakikoDate ) {
			    kakikoDate = new Date(Date.parse(this.target.ita.getAttribute(this.target.sureId, "lastModified")));
	        }
	        if( ! kakikoDate ) {
			    kakikoDate = new Date();
	        }
        }

		var postData = "submit=" + sub + 
		"&FROM=" + moz2chEscape("Shift_JIS",this.kakikoInfo.name) +
		"&mail=" + moz2chEscape("Shift_JIS",this.kakikoInfo.mail) +
		"&MESSAGE=" + moz2chEscape("Shift_JIS",this.kakikoInfo.msg) +
		"&bbs=" + this.target.itaID + 
		(this.SURETATE ? "&subject=" + moz2chEscape("Shift_JIS",this.kakikoInfo.subject) :
                            "&key=" + this.target.datID) +
		"&time=" + (this.SURETATE ? 1 : Math.ceil((kakikoDate.getTime())/1000)) +
		(this.SURETATE ? "" : "");

		postData = moz2chCharset.uni2sjis(postData);

		return postData;
	},

	setChannel: function(uChannel) {
		uChannel.setUploadStream(this.uiStream, "text/plain; charset=Shift_JIS", -1);

		return uChannel;
	},

    post: function () {
        try{
		var uri = this.setUri()
	    
		this.channel = this.ioService.newChannelFromURI(uri)
                    .QueryInterface(Components.interfaces.nsIHttpChannel);
	    
		this.uiStream = Components.classes["@mozilla.org/io/string-input-stream;1"]
                .createInstance(Components.interfaces.nsIStringInputStream);
		this.uiStream = this.uiStream.QueryInterface(Components.interfaces.nsISeekableStream);
	    
		this.dbiStream = Components.classes["@mozilla.org/binaryinputstream;1"]
                .createInstance(Components.interfaces.nsIBinaryInputStream);
	    
	    this.setRequestHeaders();
	    this.setPostData();
	    this.htmlRes = "";
	    this.statusCode = null;
	    
	    this.channel.notificationCallbacks =  this.ifRequestor;
	    this.channel.requestMethod = "POST";
	    this.channel.redirectionLimit = 0;  //Redirectʎʤ
	    this.channel.asyncOpen(this, this, 0);
        }catch(e){
            alert("moz2chKaiko post Error => " + e);
        }
    },

	setUri: function () {
	    var uri = Components.classes["@mozilla.org/network/standard-url;1"]
            .createInstance(Components.interfaces.nsIURI);
	    uri.spec = "http://" + this.target.sabaID + "/test/bbs.cgi";

		return uri;
	},
    
    onDataAvailable: function (request, ctxt, input, offset, count) {
        try{
            this.dbiStream.setInputStream(input);
            var str = this.dbiStream.readBytes(count);
            str = str.replace(/\x00/g, "*");
            this.htmlRes += str;
        }catch(e){}           
    },
    
    
    ////////////////////////////////
    // implements nsIRequestObserver
    onStartRequest: function (request, ctxt) {},
    onStopRequest: function (request, ctxt, status) {
	try{
	    this.statusCode = this.channel.responseStatus;
	    this.parse();
        if( this.htmlRes.length > 0 ) {
		this.msg = this.makeMsg();
            } else {
                //Response-BodyʤϡơɤȽ
                switch( this.statusCode ){
		    case 301:	    //30XϥRedirectȽ
		    case 302:
                    break;
		    default:			
		    
                }
                this.msg = this.getString("resmsg");
            }
	    //٥ȥꥹʡFireۥȤloaded()ǸƤӤ
	    for( i=0; i < this.dataLoadedListener.length; i++ ) {
		this.dataLoadedListener[i].onDataLoaded( {} );
	    }
	    
	}catch(e){
            alert(e);
        }
    },
    
	makeMsg: function () {
		return moz2chCharset.sjis2uni(this.msg);
	},

    ////////////////////////////////
    // implements nsIInterfaceRequestor
    ifRequestor: {
        getInterface: function ( uuid ) {
            return this;
        },
        ////////////////////////////////
        // implements nsIProgressEventSink
        onStatus : function ( request, context, status, statusArg ) {},
        onProgress : function ( request, context, progress, progressMax ) {},
        ////////////////////////////////
        // implements nsIHttpEventSink
        onRedirect : function ( httpchannel, newchannel ) {},

    },

    parse: function () {
	try{
            this.htmlTitle = String(this.htmlRes.match(/<title>\S+<\/title>/)); //title򎹎ގ
	    this.htmlTitle = String(this.htmlTitle.replace(/<\/*title>/g, "")); 
	    this.tag2ch = String(this.htmlRes.match(/<!-- 2ch_X:\w+ -->/));     //2ch򎹎ގ
	    this.msg = String(this.htmlRes.replace(/<br\/*>/g, "\n"));          //Ҏޤ򎹎ގ
	    this.msg = String(this.msg.replace(/<\/*.+?>/g, ""));
            this.msg = String(this.msg.replace(/\n{3}/g, "\n"));
        }catch(e){
            moz2ch.debug(e);
        }
    },
    
    isSuccess: function() {
	var rv = false;
        //Moz2chȯǤʤɎΎڎΎߎξȽ
        if ( this.htmlRes.length <= 0 ) {
            rv = true;
        } else {
	    if( this.getHtmlTitle() == this.getString("writeSuccess")){
		     rv = true;
		 }
        }
	return rv;
    },

	getHtmlTitle: function () {
		return moz2chCharset.sjis2uni(this.htmlTitle);
	},

    addDataLoadedListener: function( listener ) {
        this.dataLoadedListener.push( listener );
    },
}
