/* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * <pre lang="ja">
 * (_(    
 * ( `)   Moz2chΥᥤ󥹥ץȤʡ
 * (      )     : 2005/01/27
 *      񤤤  : ˼⤸顼
 * (___)__)   Ď؎ˎގ: ĶAnne
 *                      : ؤ41椵
 *                      : 󤵤
 *                      : (ߢώ)(ߢώ) tRZ80FPU5k
 *            FindBar!
 *            
 * </pre>
 */

const kMoz2chVersion = "0.00.20080619";
const kMoz2chUA = "Monazilla/1.00 (Moz2ch/" + kMoz2chVersion + ")";

const Ci = Components.interfaces;
const Cc = Components.classes;

var moz2ch = {
    // constants
    version: kMoz2chVersion,	// Moz2ch version
    ua: kMoz2chUA,		// Monazilla UA

    // Uninitialized datas
    bundle: null,
    currentTitle: null,
    currentURL: null,
    debugArea: null,
    statusText: null,
    defaultStatusText: null,
    separator: "",
    sureCount: null,
    sureCountPref: null,
    reloadBoardTree: null,
    pan: null,

    bbsManager: null,

    // ߤΥǡĥĥ꡼ġ
    currentView: null,
    itaTreeView: null,
    itaView:null,
    sureView:null,

    itaTree: null,
    ita: null,
    sure: null,

	findBar: null,

    debugMax: null,    //debugAreaιԿ -1̵

    // Ѥskin̾
    skinName: null,

    moz2chPrefListener: null,

    // Initialize
    init: function () {
        this.debugArea = document.getElementById("debugArea");
        this.bundle = document.getElementById("moz2chBundle");
        this.separator = this.getString("dataSeparator");
        this.currentTitle = document.getElementById("currentTitle");
        this.currentURL = document.getElementById("urlbar");

        //prefsɤ߹
	this.loadPref();

	var prefs=Components.classes['@mozilla.org/preferences;1'].getService(Components.interfaces.nsIPrefBranch);
	try{
		if(!prefs.getCharPref("app.version").match("1."))
			document.getElementById("find-field").disabled = true;
	}catch(e){
		//trunkȤǤapp.versionʤΤǥ顼롣
	}

var basePrefListener = {
	    domain  : 'moz2ch',
	    
	    observe : function(aSubject, aTopic, aPrefstring) {
		if (aTopic != 'nsPref:changed' || !aPrefstring.match(this.domain)){
		    return;
		}else{
		    this.applyPrefs(aPrefstring);
		}
	    }
	};

moz2chPrefListener = basePrefListener;

	addPrefListener(moz2chPrefListener); // Ͽ

        this.initItaSure();

        this.defaultStatus();
        moz2chDebugSplitterSync();

        // Welcome debug message
        this.debug("Welcome to Moz2ch version " + this.version + ".\n"
                + "Here is debug text output area, and this is test debug message.");
    },

    loadPref: function() {
	var useSkin;
	if(nsPreferences.getIntPref("moz2ch.debugMax")){
	    this.debugMax = nsPreferences.getIntPref("moz2ch.debugMax");
	}else{
	    this.debugMax = 50;
	    nsPreferences.setIntPref("moz2ch.debugMax", this.debugMax);
	}
	if(nsPreferences.getBoolPref("moz2ch.enable3columns") != null){
	    this.pan = nsPreferences.getBoolPref("moz2ch.enable3columns");
	}else{
	    this.pan = false;
	    nsPreferences.setBoolPref("moz2ch.enable3columns", this.pan);
	}
	if(nsPreferences.getLocalizedUnicharPref("moz2ch.skin")){
	    this.skinName = nsPreferences.getLocalizedUnicharPref("moz2ch.skin");
	    useSkin = moz2chskin.existsSkinDir(this.skinName);
	    if(useSkin != this.skinName){
		this.skinName = useSkin;
		nsPreferences.setUnicharPref("moz2ch.skin", this.skinName);
	    }   
	}else{
	    this.skinName = "default";
	    nsPreferences.setUnicharPref("moz2ch.skin", this.skinName);
	}
	if(nsPreferences.getIntPref("moz2ch.sureCountDefault")){
	    this.sureCountPref = nsPreferences.getIntPref("moz2ch.sureCountDefault");
	}else{
	    this.sureCountPref = -1
	    nsPreferences.setIntPref("moz2ch.sureCountDefault", this.sureCountPref);
	}
	if(this.sureCountPref != -1){
	    document.getElementById("viewNum").value = this.sureCountPref;
	    this.sureCount = this.sureCountPref;
	}else{
	    document.getElementById("viewNum").value = "ALL"
	    this.resetSureCount();   
	}
	if(nsPreferences.getBoolPref("moz2ch.sureDisplayAbone") != null){
	    this.popupAbone = nsPreferences.getBoolPref("moz2ch.sureDisplayAbone");
	}else{
	    this.popupAbone = false;
	    nsPreferences.setBoolPref("moz2ch.sureDisplayAbone", this.popupAbone);
	}
	if(nsPreferences.getBoolPref("moz2ch.enableBTReload") != null){
	    this.reloadBoardTree = nsPreferences.getBoolPref("moz2ch.enableBTReload");
	}else{
	    this.reloadBoardTree = false;
	    nsPreferences.setBoolPref("moz2ch.enableBTReload", this.reloadBoardTree);
	}
    },
    
    applyPrefs: function (target) {
	switch(target){
	    case "moz2ch.itatreeurl":
	        this.itaTreeView.data.url = nsPreferences.getLocalizedUnicharPref("moz2ch.itatreeurl");
	        this.itaTreeView.reload();
	        break;
	    case "moz2ch.enableBTReload":
	        break;
	    case "moz2ch.resetExtract":
	        this.itaView.resetExtract = nsPreferences.getBoolPref("moz2ch.resetExtract");
	        break;
	    case "moz2ch.popupColor":
	        this.sureView.popupColor = "#" + nsPreferences.getLocalizedUnicharPref("moz2ch.popupColor");
	        break;
	    case "moz2ch.enableImgPopup":
	        this.sureView.canImgPopup = nsPreferences.getBoolPref("moz2ch.enableImgPopup");
	        break;
	    case "moz2ch.skin":
			this.skinName = nsPreferences.getLocalizedUnicharPref("moz2ch.skin");
			moz2chReloadAllSkins();
	        break;
	    case "moz2ch.skinCheckFlag":
	        break;
	    case "moz2ch.enable3columns":
	        this.initItaSure();
	        break;
	    case "moz2ch.sureCountDefault":
	        this.sureCountPref = nsPreferences.getIntPref("moz2ch.sureCountDefault");
	        this.changeViewResNum(moz2ch.sureCountPref);
	        break;
	    case "moz2ch.sureDisplayAbone":
	        this.popupAbone = nsPreferences.getBoolPref("moz2ch.sureDisplayAbone");
	        break;
	    case "moz2ch.debugMax":
	        this.debugMax = nsPreferences.getIntPref("moz2ch.debugMax");
	        break;
	    case "moz2ch.bookmarks.folderId":
	        document.getElementById("bookmarks-view").update();
	        break;
	    case "moz2ch.sureNormalLinkwithTab":
	        this.sureView.tabLink = nsPreferences.getBoolPref("moz2ch.sureNormalLinkwithTab");
	        break;
	    default:
	        this.debug("???");
	}
    },

    reload: function () {
        if (this.currentView && this.currentView.data){
            if (this.currentView == this.sureView){
		this.sureView.load_flag = 0;
                this.itaView.saveCurSurePos();
		this.sureView.removePopup();
	    }
            this.currentView.reload();
	}
    },

    setCurrent: function (view) {
        var d;
        if (d = view.data) {
            this.currentView = view;
            this.setCurrentTitle(d.getTitle());
            this.setCurrentURL(d.url);
        }
    },
    
    getString: function (key) {
        if (!this.bundle)
            this.bundle = document.getElementById("moz2chBundle");
    
        try {
            return this.bundle.getString(key);
        } catch (e) {
            this.debug(e);
        }
    },
    
    setCurrentTitle: function (title) {
        this.currentTitle.value = title;
    },

    setCurrentURL: function (URL) {
        this.currentURL.value = URL;
    },

    defaultStatus: function (status) {
	if(status){
	    this.defaultStatusText = status;
	}else{
	    if(!this.defaultStatusText)
	        this.defaultStatusText = this.getString("defaultStatus");    
	}
	//window.XULBrowserWindow.setDefaultStatus(this.defaultStatusText);
	moz2chXULBrowserWindow.setDefaultStatus(this.defaultStatusText)
    },

    status: function (status) {
	if(status){
	    this.statusText = status;
	}else{
	    this.statusText = "";
	}
	//window.XULBrowserWindow.setStatus(this.statusText);
	moz2chXULBrowserWindow.setStatus(this.statusText);
    },

    checkStatusDefault: function () {
	//return window.XULBrowserWindow.defaultStatus;
	return moz2chXULBrowserWindow.defaultStatus;
    },
    
    debug: function (msg) {
        if (!this.debugArea)
            this.debugArea = document.getElementById("debugArea");
    
        msg = msg + "\n"
                  + "----------------------------------------------------------------\n";
		
        if ( this.debugMax > 0 ) {
            var lines = (this.debugArea.value).split("\n");
            msg += (lines.splice(0, this.debugMax - 2)).join("\n");
        } else {
            msg += this.debugArea.value;
        }
			
        this.debugArea.value = msg;
    },

    examine: function (obj) {
        var s = "";
        for (var i in obj) {
            try {
                s += i + " = " + obj[i] + "\n";
            } catch (e) {
                s += i + "\n";
            }
        }
        this.debug(s);
    },

    close: function () {
		try{
			return this.WindowIsClosing();
		}catch(e){ this.debug(e); }
    },

    initItaSure: function () {
        //ǽ3ɽƸ
        if ( this.pan ) {
            document.getElementById("itasure").setAttribute("orient","horizontal");
            document.getElementById("itaSplitter").setAttribute("orient","horizontal");
        } else {
            document.getElementById("itasure").setAttribute("orient","vertical");
            document.getElementById("itaSplitter").setAttribute("orient","vertical");
        }
    },

    setBusy: function( flag ) {
/*        if ( flag )
            document.getElementById("navigator-throbber").setAttribute("busy" , "true");
        else
            document.getElementById("navigator-throbber").removeAttribute("busy");*/
    },

    resetSureCount: function () {
        this.sureCount = 99999;
    },

    changeViewResNum: function(value) {
	this.sureCountPref = value;
	if(value != -1){
	    document.getElementById("viewNum").value = value;
	    this.sureCount = value;
	}else{
	    document.getElementById("viewNum").value = "ALL";
	    this.resetSureCount();
	}
	nsPreferences.setIntPref("moz2ch.sureCountDefault", value);
	if(this.sureView.data)
	this.sureView.reGet();
    }
};

var subScriptLoader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
                    .getService(Components.interfaces.mozIJSSubScriptLoader);
subScriptLoader.loadSubScript("chrome://browser/content/browser.js", moz2ch);
subScriptLoader.loadSubScript("chrome://browser/content/nsContextMenu.js", moz2ch);
subScriptLoader.loadSubScript("chrome://browser/content/utilityOverlay.js", moz2ch);
subScriptLoader.loadSubScript("chrome://browser/content/places/browserPlacesViews.js", moz2ch);
subScriptLoader.loadSubScript("chrome://browser/content/places/editBookmarkOverlay.js", moz2ch);

__defineGetter__("PlacesUtils", function() {
  delete this.PlacesUtils
  var tmpScope = {};
  Components.utils.import("resource://gre/modules/PlacesUtils.jsm", tmpScope);
  return this.PlacesUtils = tmpScope.PlacesUtils;
});

[
  ["gBrowser",            "content"],
  ["gNavToolbox",         "navigator-toolbox"],
  ["gURLBar",             "urlbar"],
  ["gNavigatorBundle",    "bundle_browser"]
].forEach(function (elementGlobal) {
  var [name, id] = elementGlobal;
  window.__defineGetter__(name, function () {
    var element = document.getElementById(id);
    if (!element)
      return null;
    delete window[name];
    return window[name] = element;
  });
  window.__defineSetter__(name, function (val) {
    delete window[name];
    return window[name] = val;
  });
});

var gFindBarInitialized = false;
XPCOMUtils.defineLazyGetter(window, "gFindBar", function() {
  let XULNS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
  let findbar = document.createElementNS(XULNS, "findbar");
  findbar.setAttribute("browserid", "content");
  findbar.id = "FindToolbar";

  let browserBottomBox = document.getElementById("browser-bottombox");
  browserBottomBox.insertBefore(findbar, browserBottomBox.firstChild);

  // Force a style flush to ensure that our binding is attached.
  findbar.clientTop;
  window.gFindBarInitialized = true;
  return findbar;
});

__defineGetter__("gPrefService", function() {
  delete this.gPrefService;
  return this.gPrefService = Services.prefs;
});

__defineGetter__("XULBrowserWindow", function(){return  moz2ch.XULBrowserWindow; });

__defineGetter__("OfflineApps", function(){ return moz2ch.OfflineApps; });

/////////////////
// Event Handlers
function moz2chLoad() {
    // Navigator startup
	try{
		moz2chStartup();
	}catch(e){
		alert(e);
	}
    try{
	gBrowser.browsers[0].setAttribute("disablehistory","true");
	moz2ch.findBar = document.getElementById("FindToolbar");

	moz2ch.init();
	moz2chskin.init();
	moz2ch.itaTreeView = new moz2chItaTreeView();
	moz2ch.itaTreeView.init();
	moz2ch.itaTreeView.splitterSync();
	moz2ch.itaView = new moz2chItaView();
	moz2ch.itaView.init();
	moz2ch.itaView.syncSplitter();
	moz2ch.sureView = new moz2chSureView();
	moz2ch.sureView.init();
	moz2ch.sureView.element.selectedTab = moz2ch.sureView.element.mCurrentTab;
	moz2ch.bbsManager = new moz2chBBSManager();
	moz2ch.itaTreeView.addBBSMenuItem(moz2ch.getString("moz2chYahoo"), "yahoo");
	moz2ch.itaTreeView.addBBSMenuItem(moz2ch.getString("moz2chMachi"), "machi");
	moz2ch.itaTreeView.addBBSMenuItem(moz2ch.getString("moz2chJbbs"), "jbbs");
	var moz2ch2ch = moz2ch.bbsManager.createItaTree( "2ch", moz2ch.getString("moz2ch2ch"));
	
	moz2ch.itaTreeView.load(moz2ch2ch);

	if(moz2ch.reloadBoardTree == true)
	    moz2ch.itaTreeView.reload();

    }catch(e) { moz2ch.debug(e); }
}

function moz2chReload() {
    moz2ch.reload();
}

function moz2chUnload() {
	try{
	if(moz2ch.sureView){
        var l = moz2ch.sureView.element.mTabContainer.childNodes.length;
        for(var i=0; i<l; i++){
		    if(moz2ch.sureView.element.mTabContainer.childNodes[i].sure){
				if(moz2ch.sureView.element.selectedTab != moz2ch.sureView.element.mTabContainer.childNodes[i])
                     moz2ch.sureView.element.selectedTab = moz2ch.sureView.element.mTabContainer.childNodes[i];
                moz2ch.itaView.saveCurSurePos();
				moz2ch.sureView.element.mTabContainer.childNodes[i].sure.ita.writeIndex();
            }
        }
	}

    removePrefListener(moz2chPrefListener);
	delete moz2ch.itaTreeView;
	delete moz2ch.itaView;
	delete moz2ch.sureView;

	try{
    moz2ch.BrowserShutdown();
	moz2chXULBrowserWindow.destroy();
}catch(e){}
	  window.QueryInterface(Ci.nsIInterfaceRequestor)
        .getInterface(moz2ch.nsIWebNavigation)
        .QueryInterface(Ci.nsIDocShellTreeItem).treeOwner
        .QueryInterface(Ci.nsIInterfaceRequestor)
        .getInterface(Ci.nsIXULWindow)
        .XULBrowserWindow = null;
	delete moz2ch.moz2chXULBrowserWindow;
	
	window.QueryInterface(Ci.nsIDOMChromeWindow).browserDOMWindow = null;

  if (moz2ch.appCore)
    moz2ch.appCore.close();

	delete moz2ch;

	}catch(e){ alert(e); }
}

function moz2chDebugToggle() {
    goToggleToolbar("debugBox", "showDebug");
    moz2chDebugSplitterSync();
}

function moz2chDebugSplitterSync() {
    document.getElementById("debugSplitter").setAttribute("hidden", document.getElementById("debugBox").getAttribute("hidden"));
}

function moz2chBBSMenuListChange ( value ) {
    try{
	var itaTree = moz2ch.bbsManager.createItaTree( value );
	moz2ch.itaTreeView.setRDFRootURI(itaTree.rdfRootURI);
	moz2ch.itaTreeView.load(itaTree);
	
    }catch(e){
	moz2ch.debug(e);
    }
}

function moz2chChangeViewResNum ( value ) {
    moz2ch.changeViewResNum(value);
}

function addPrefListener(aObserver) {
    try {
        var pbi = Components.classes['@mozilla.org/preferences;1'].getService(Components.interfaces.nsIPrefBranchInternal);
        pbi.addObserver(aObserver.domain, aObserver, false);
    } catch(e) {}
}

function removePrefListener(aObserver) {
    try {
        var pbi = Components.classes['@mozilla.org/preferences;1'].getService(Components.interfaces.nsIPrefBranchInternal);
        pbi.removeObserver(aObserver.domain, aObserver);
    } catch(e) { alert(e); }
}

moz2chOpenFileWindow =
function() {
    try {
	const nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, gNavigatorBundle.getString("openFile"), nsIFilePicker.modeOpen);

	fp.appendFilter("2ch dat","*.dat"); 
	
	if (fp.show() == nsIFilePicker.returnOK)
	moz2ch.sureView.openLocalDat(fp.fileURL.spec);
    } catch (e) {
		moz2ch.debug(e);
    }
} 

function moz2chRemoveTaborWindow () {
    try{
	if ( moz2ch.sureView.element.mTabContainer.childNodes.length > 1){
	    moz2ch.sureView.element.removeCurrentTab();
		return;
	}
	if(moz2ch.sureView){
        var l = moz2ch.sureView.element.mTabContainer.childNodes.length;
        for(var i=0; i<l; i++){
		    if(moz2ch.sureView.element.mTabContainer.childNodes[i].sure){
				if(moz2ch.sureView.element.selectedTab != moz2ch.sureView.element.mTabContainer.childNodes[i])
                     moz2ch.sureView.element.selectedTab = moz2ch.sureView.element.mTabContainer.childNodes[i];
                moz2ch.itaView.saveCurSurePos();
				moz2ch.sureView.element.mTabContainer.childNodes[i].sure.ita.writeIndex();
            }
        }
	}
    removePrefListener(moz2chPrefListener);
	delete moz2ch.itaTreeView;
	delete moz2ch.itaView;
	delete moz2ch.sureView;
	delete moz2ch;

    closeWindow(true);
    }catch(e){ alert(e); }
}

function moz2chBrowserTryToCloseWindow()
{
  if (moz2ch.WindowIsClosing()) {
	if(moz2ch.sureView){
        var l = moz2ch.sureView.element.mTabContainer.childNodes.length;
        for(var i=0; i<l; i++){
		    if(moz2ch.sureView.element.mTabContainer.childNodes[i].sure){
				if(moz2ch.sureView.element.selectedTab != moz2ch.sureView.element.mTabContainer.childNodes[i])
                     moz2ch.sureView.element.selectedTab = moz2ch.sureView.element.mTabContainer.childNodes[i];
                moz2ch.itaView.saveCurSurePos();
				moz2ch.sureView.element.mTabContainer.childNodes[i].sure.ita.writeIndex();
            }
        }
	}
    removePrefListener(moz2chPrefListener);
	delete moz2ch.itaTreeView;
	delete moz2ch.itaView;
	delete moz2ch.sureView;
	delete moz2ch;

    window.close();     // WindowIsClosing does all the necessary checks
  }
}

function moz2chClose () {
    return moz2ch.close();
}

function moz2chStop() {
    moz2ch.itaTreeView.stop();
    moz2ch.itaView.stop();
    moz2ch.sureView.stop();
}
function moz2chCheckKey(event) {
	switch(event.keyCode){
	case event.DOM_VK_RETURN :
		moz2chGoRes();
	break;
	default :
	break;
	}
}

function moz2chGoRes() {
	var win=document.getElementById('content');
	var num=document.getElementById('go').value;

	// DoubleByte-Number -> SingleByte-Number
	var han = "0123456789";
	var zen = "";
	var toHankakuNumStr = "";
	for (i=0; i<num.length; i++){
		c = num.charAt(i);
		n = zen.indexOf(c,0);
		if (n >= 0) c = han.charAt(n);
		toHankakuNumStr += c;
	}
	num = toHankakuNumStr;

 	if(!num||!parseInt(num)){
		num=moz2ch.sureView.data.sureAcq;
	}

	if(parseInt(num)>moz2ch.sureView.data.sureAcq)
		num = moz2ch.sureView.data.sureAcq;
	win.loadURI(win.currentURI.spec.replace(/\#\d*$/,'')+'#'+num);
}

function moz2chReloadAllSkins () {
	var l = moz2ch.sureView.element.mTabContainer.childNodes.length;
    for(var i=0; i<l; i++){
	    if(moz2ch.sureView.element.mTabContainer.childNodes[i].sure){
         	moz2ch.sureView.element.mTabContainer.childNodes[i].sure.getSkin();
    	}
	}
}

function moz2chStartup() {
  moz2ch.TabsOnTop.enabled = true;
  moz2chprepareForStartup();

  // Set a sane starting width/height for all resolutions on new profiles.
  if (!document.documentElement.hasAttribute("width")) {
    let defaultWidth = 994;
    let defaultHeight;
    if (screen.availHeight <= 600) {
      document.documentElement.setAttribute("sizemode", "maximized");
      defaultWidth = 610;
      defaultHeight = 450;
    }
    else {
      // Create a narrower window for large or wide-aspect displays, to suggest
      // side-by-side page view.
      if (screen.availWidth >= 1600)
        defaultWidth = (screen.availWidth / 2) - 20;
      defaultHeight = screen.availHeight - 10;
    }
    document.documentElement.setAttribute("width", defaultWidth);
    document.documentElement.setAttribute("height", defaultHeight);
  }

  moz2ch.CombinedStopReload.init();

  moz2ch.allTabs.readPref();

  moz2ch.TabsOnTop.syncCommand();

  moz2ch.BookmarksMenuButton.init();

  moz2ch.PlacesStarButton.init();
  moz2ch.FullZoom.init();
  setTimeout(moz2ch.delayedStartup, 0, false, false);
}

function moz2chprepareForStartup() {
  gBrowser.addEventListener("DOMUpdatePageReport", moz2ch.gPopupBlockerObserver.onUpdatePageReport, false);

  gBrowser.addEventListener("PluginNotFound",    moz2ch.gPluginHandler, true);
  gBrowser.addEventListener("PluginCrashed",     moz2ch.gPluginHandler, true);
  gBrowser.addEventListener("PluginBlocklisted", moz2ch.gPluginHandler, true);
  gBrowser.addEventListener("PluginOutdated",    moz2ch.gPluginHandler, true);
  gBrowser.addEventListener("PluginDisabled",    moz2ch.gPluginHandler, true);
  gBrowser.addEventListener("NewPluginInstalled", moz2ch.gPluginHandler.newPluginInstalled, true);

  Services.obs.addObserver(moz2ch.gPluginHandler.pluginCrashed, "plugin-crashed", false);

  window.addEventListener("AppCommand", moz2ch.HandleAppCommandEvent, true);

  var webNavigation;
  try {
    webNavigation = moz2ch.getWebNavigation();
    if (!webNavigation)
      throw "no XBL binding for browser";
  } catch (e) {
    alert("Error launching browser window:" + e);
    window.close(); // Give up.
    return;
  }

  // initialize observers and listeners
  // and give C++ access to gBrowser
  moz2chXULBrowserWindow.init();
  window.QueryInterface(Ci.nsIInterfaceRequestor)
        .getInterface(moz2ch.nsIWebNavigation)
        .QueryInterface(Ci.nsIDocShellTreeItem).treeOwner
        .QueryInterface(Ci.nsIInterfaceRequestor)
        .getInterface(Ci.nsIXULWindow)
        .XULBrowserWindow = moz2chXULBrowserWindow;
  window.QueryInterface(Ci.nsIDOMChromeWindow).browserDOMWindow =
    new moz2ch.nsBrowserAccess();

  // set default character set if provided
  if ("arguments" in window && window.arguments.length > 1 && window.arguments[1]) {
    if (window.arguments[1].indexOf("charset=") != -1) {
      var arrayArgComponents = window.arguments[1].split("=");
      if (arrayArgComponents) {
        //we should "inherit" the charset menu setting in a new window
        moz2ch.getMarkupDocumentViewer().defaultCharacterSet = arrayArgComponents[1];
      }
    }
  }

  gBrowser.docShell;

  webNavigation.sessionHistory = Components.classes["@mozilla.org/browser/shistory;1"]
                                           .createInstance(Components.interfaces.nsISHistory);
  // enable global history
  try {
    gBrowser.docShell.QueryInterface(Components.interfaces.nsIDocShellHistory).useGlobalHistory = true;
  } catch(ex) {
    Components.utils.reportError("Places database may be locked: " + ex);
  }
  // hook up UI through progress listener
  gBrowser.addProgressListener(window.XULBrowserWindow, Components.interfaces.nsIWebProgress.NOTIFY_ALL);
  gBrowser.addTabsProgressListener(window.TabsProgressListener);

  // setup our common DOMLinkAdded listener
  gBrowser.addEventListener("DOMLinkAdded", moz2ch.DOMLinkHandler, false);

  // setup our MozApplicationManifest listener
  gBrowser.addEventListener("MozApplicationManifest",
                            OfflineApps, false);
}

function handleDroppedLink(event, url, name)
{
  let postData = { };
  let uri = getShortcutOrURI(url, postData);
  if (uri)
    loadURI(uri, null, postData.value, false);

  // Keep the event from being handled by the dragDrop listeners
  // built-in to gecko if they happen to be above us.
  event.preventDefault();
};

function goToggleToolbar( id, elementID )
{
    var toolbar = document.getElementById(id);
    var element = document.getElementById(elementID);
    if (toolbar)
    {
        var isHidden = toolbar.hidden;
        toolbar.hidden = !isHidden;
        document.persist(id, 'hidden');
        if (element) {
            element.setAttribute("checked", isHidden ? "true" : "false");
            document.persist(elementID, 'checked');
        }
    }
}
