/* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * <pre lang="ja">
 * (_(    
 * ( `)   ʡ
 * (      )     : 2003/08/17
 *      񤤤  : (ߢώ)(ߢώ) tRZ80FPU5k
 * (___)__)   Ď؎ˎގ: 
 *            
 * </pre>
 */


/////////////////

const kMoz2chskinDir = "skin";
const kMoz2chdefaultskin = "default";

const kMoz2chskinHeader = "header.html";
const kMoz2chskinRes    = "res.html";
const kMoz2chskinNewres = "newres.html";
const kMoz2chskinFooter = "footer.html";

const fontFamily = moz2chCharset.euc2uni('"ͣ Хå","MS PGothic",Osaka,"IPAMonaPGothic","Mona","mona-gothic-jisx0208.1990-0",monospace');

var moz2chskin = {

    init: function() {
	try{
        // defaultΥե뤬ʤк
        var moz2chDir = new Dir(this.getskinPath());

        moz2chDir.append(kMoz2chdefaultskin);
        if (! moz2chDir.exists())
            moz2chDir.create(kMoz2chDataDirPerm);

	var checkFlag;
	if(nsPreferences.getBoolPref("moz2ch.skinCheckFlag") != null){
	    checkFlag = nsPreferences.getBoolPref("moz2ch.skinCheckFlag");
	}else{
	    checkFlag = true;
	    nsPreferences.setBoolPref("moz2ch.skinCheckFlag", checkFlag);
	}
	
	var old_html;
	var html = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n"
		 + "<html lang=\"ja-JP\">\n"
                 + " <head>\n"
                 + "  <meta http-equiv=\"Content-Type\" content=\"text/html; charset=Shift_JIS\">\n"
		 + "  <meta http-equiv=\"Content-Style-Type\" content=\"text/css\">\n"
                 + "  <title><THREADNAME/></title>\n"
                 + "  <style type=\"text/css\">\n"
		 + "    <!--\n"
		 + "       body {font-family:<MOZ2CHFONT/>}\n"
		 + "       b.title    {color: red}\n"
		 + "        .mailname {color: green}\n"
		 + "        .new      {color: red}\n"
		 + "        .name     {color: green}\n"
		 + "    -->\n"
		 + "  </style>\n"
                 + " </head>\n"
                 + " <body>\n"
                 + "   <b class=\"title\"><THREADNAME/></b>\n"
                 + "   <br>\n";
        var f = new File(moz2chDir.path);
        f.append(kMoz2chskinHeader);
        if (!f.exists()) {
            f.open("w", kMoz2chDataFilePerm);
            f.write(html);
            f.close();
        }else if(checkFlag){
	    f.open("r");
	    old_html = f.read();
	    f.close();
	    if(old_html != html){
		f.remove();
		f = new File(moz2chDir.path);
		f.append(kMoz2chskinHeader);
		f.open("w", kMoz2chDataFilePerm);
		f.write(html);
		f.close();
	    }
	}
        f = new File(moz2chDir.path);
        f.append(kMoz2chskinRes);
	html=moz2ch.getString("defaultSkinRes");
        if (!f.exists()) {
            f.open("w", kMoz2chDataFilePerm);
            f.write(moz2chCharset.uni2euc(html));
            f.close();
        }else if(checkFlag){
	    f.open("r");
	    old_html = f.read();
	    f.close();
	    if(old_html != html){
		f.remove();
		f = new File(moz2chDir.path);
		f.append(kMoz2chskinRes);
		f.open("w", kMoz2chDataFilePerm);
		f.write(moz2chCharset.uni2euc(html.replace(/\r\n/g, "\n")));
		f.close();
	    }
	}
	
	html = moz2ch.getString("defaultSkinNew");
	html = html.replace(/\r\n/g,'\n');
        f = new File(moz2chDir.path);
        f.append(kMoz2chskinNewres);
        if (!f.exists()) {
            f.open("w", kMoz2chDataFilePerm);
            f.write(moz2chCharset.uni2euc(html));
            f.close();
        }else if(checkFlag){
 	    f.open("r");
	    old_html = f.read();
	    f.close();
	    if(old_html != html){
		f.remove();
		f = new File(moz2chDir.path);
		f.append(kMoz2chskinNewres);
		f.open("w", kMoz2chDataFilePerm);
		f.write(moz2chCharset.uni2euc(html));
		f.close();
	    }
	}

	html = " </body>\n"
             + "</html>\n";
        f = new File(moz2chDir.path);
        f.append(kMoz2chskinFooter);
        if (!f.exists()) {
            f.open("w", kMoz2chDataFilePerm);
            f.write(html);
            f.close();
        }else if(checkFlag){
	    f.open("r");
	    old_html = f.read();
	    f.close();
	    if(old_html != html){
		f.remove();
		f = new File(moz2chDir.path);
		f.append(kMoz2chskinFooter);
		f.open("w", kMoz2chDataFilePerm);
		f.write(html);
		f.close();
	    }
	}
	}catch(e){ alert(e); }
    },

    skinHeader: null,
    getHeader: function(skin) {
        if (!this.skinHeader) {
            var moz2chDir = new Dir(this.getskinPath());
            moz2chDir.append(skin);
            if (!moz2chDir.exists()){
				moz2chDir = new Dir(this.getskinPath());
				moz2chDir.append(kMoz2chdefaultskin);
	    	}
            var f = new File(moz2chDir.path);
            f.append(kMoz2chskinHeader);
            if (!f.exists())
                return false;
            f.open("r");
            this.skinHeader = moz2chCharset.euc2uni(f.read());
            f.close();
        }
        return this.skinHeader.replace(/<MOZ2CHFONT\/>/g, fontFamily);
    },

    skinRes: null,
    getRes: function(skin) {
        if (!this.skinRes) {
            var moz2chDir = new Dir(this.getskinPath());
            moz2chDir.append(skin);
            if (!moz2chDir.exists()){
		moz2chDir = new Dir(this.getskinPath());
		moz2chDir.append(kMoz2chdefaultskin);
	    }
            var f = new File(moz2chDir.path);
            f.append(kMoz2chskinRes);
            if (!f.exists())
                return false;
            f.open("r");
            this.skinRes = moz2chCharset.euc2uni(f.read());
            f.close();
        }
        return this.skinRes;
    },

    skinNewres: null,
    getNewres: function(skin) {
        if (!this.skinNewres) {
            var moz2chDir = new Dir(this.getskinPath());
            moz2chDir.append(skin);
            if (!moz2chDir.exists()){
		moz2chDir = new Dir(this.getskinPath());
		moz2chDir.append(kMoz2chdefaultskin);
	    }
            var f = new File(moz2chDir.path);
            f.append(kMoz2chskinNewres);
            if (!f.exists())
                return false;
            f.open("r");
            this.skinNewres = moz2chCharset.euc2uni(f.read());
            f.close();
        }
        return this.skinNewres;
    },

    skinFooter: null,
    getFooter: function(skin) {
        if (!this.skinFooter) {
            var moz2chDir = new Dir(this.getskinPath());
            moz2chDir.append(skin);
            if (!moz2chDir.exists()){
		moz2chDir = new Dir(this.getskinPath());
		moz2chDir.append(kMoz2chdefaultskin);
	    }
            var f = new File(moz2chDir.path);
            f.append(kMoz2chskinFooter);
            if (!f.exists())
                return false;
            f.open("r");
            this.skinFooter = moz2chCharset.euc2uni(f.read());
            f.close();
        }
		var moz2chDir = new Dir(moz2chskin.getskinPath());
		moz2chDir.append(moz2ch.skinName);
		var skinPath = moz2chDir.path?'file:///'+moz2chDir.path.replace(/\ /g, "%20").replace(/\\/g, "\/"):'';

        return this.skinFooter.replace(/<SKINPATH\/>/g, skinPath);
    },

    skinDir: null,
    getskinPath: function() {
        if (!this.skinDir) {
            var dirUtils = new DirUtils();
            var skinDir = new Dir(dirUtils.getMozUserHomeDir());

            skinDir.append(kMoz2chDataDirName);

            skinDir.append(kMoz2chDataDirName);
            if (!skinDir.exists())
                skinDir.create(kMoz2chDataDirPerm);

            skinDir.append(kMoz2chskinDir);
            if (! skinDir.exists())
                skinDir.create(kMoz2chDataDirPerm);
            this.skinDir = skinDir.path
        }
        return this.skinDir;
    },

    existsSkinDir: function(skin) {
	var dir = this.getskinPath();
	var checkDir = new Dir(dir);
	checkDir.append(skin);
	if(checkDir.exists())
	return skin;
	else 
	return kMoz2chdefaultskin;
    },
};

//Ūˤǽ
//moz2chskin.init();


