/* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * <pre lang="ja">
 * (_(    
 * ( `)   ĥ꡼ǡ饹ʡ
 * (      )     : 2002/07/05
 *      񤤤  : ˼⤸顼
 * (___)__)   Ď؎ˎގ: 
 *            index.csvɤϤΥ饹Ǽʡ
 *            
 *
 * subclassϤĤŬ˼
 *    String getDataURL();    ǡURL
 *    String getLogPath();    եѥ(ʤк)֤
 *    bool parse();           ǡΥѡ
 *    
 *    void writeIndex();      ǥåν񤭽Ф
 *    void readIndex();       ǥåɤ߹
 * </pre>
 */

const kMoz2chTreeDataFileName = "index.csv";

function moz2chTreeData(title, url) {
    this.base = moz2chData;
    this.base(title, url);
}

/////////////////////
// extends moz2chData
moz2chTreeData.prototype = new moz2chData();

moz2chTreeData.prototype.baseReadLog = moz2chData.prototype.readLog;
moz2chTreeData.prototype.readLog =
function () {
    var rv = this.readIndex();
    if (!rv)
        rv = this.baseReadLog();
    return rv;
};

moz2chTreeData.prototype.onGet =
function () {
    try{
    var rv = this.parse();
    this.loaded();

    if (rv && this.data.length > 0) {
        // if parse succeeded, save the data.
        var f = new File(this.getLogPath());
        f.open("w", kMoz2chDataFilePerm);
        f.write(this.data);
        f.close();
        // write out data
        this.unload();
    }
    }catch(e){ moz2ch.debug(e); }
};

moz2chTreeData.prototype.indexPath = null;
moz2chTreeData.prototype.getIndexPath =
function () {
    if (!this.indexPath) {
        var f = new File(this.getLogPath());
        f.leaf = kMoz2chTreeDataFileName;
        this.indexPath = f.path;
    }
    return this.indexPath;
};

moz2chTreeData.prototype.readIndex =
function () {
    return false;
};

moz2chTreeData.prototype.writeIndex =
function () {
};

