/* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * <pre lang="ja">
 * (_(    
 * ( `)   ĥ꡼ǡӥ塼饹ʡ
 * (      )     : 2004/04/14
 *      񤤤  : ˼⤸顼
 * (___)__)   Ď؎ˎގ: ĶAnne
 *                      : (ߢώ)(ߢώ) tRZ80FPU5k
 *            ĥĥ꡼,ĥ饹Υѡ饹
 *            bug#34,#57եĤƤΤfixʡ
 *            
 *
 * subclassϤĤŬ˼
 *    String elementId;
 *    String splitterId;
 *    String toggleMenuId;
 *    bool hasNextSibling(rowIndex, afterIndex);
 *    String getCellText(row, colID);
 *    int getRowCount();
 * </pre>
 */

function moz2chTreeDataView() {
    this.base = moz2chDataView;
    this.base();
}

/////////////////////////
// extends moz2chDataView
moz2chTreeDataView.prototype = new moz2chDataView();

// variables
moz2chTreeDataView.prototype.splitterId = null;
moz2chTreeDataView.prototype.splitter = null;
moz2chTreeDataView.prototype.toggleMenuId = null;

moz2chTreeDataView.prototype.baseInit = moz2chDataView.prototype.init;
moz2chTreeDataView.prototype.init =
function () {
    this.baseInit();
    this.splitter = document.getElementById(this.splitterId);
    this.syncSplitter();
    this.reset();
};

moz2chTreeDataView.prototype.baseLoad = moz2chDataView.prototype.load;
moz2chTreeDataView.prototype.load =
function (data) {
    this.baseLoad(data);
    this.selection.clearSelection();
};

moz2chTreeDataView.prototype.baseReload = moz2chDataView.prototype.reload;
moz2chTreeDataView.prototype.reload =
function (data) {
    this.baseReload(data);
    this.selection.clearSelection();
};

moz2chTreeDataView.prototype.toggleView =
function () {
    moz2ch.goToggleToolbar(this.viewId, this.toggleMenuId);
	moz2ch.goToggleToolbar(this.elementId, this.toggleMenuId);
    this.syncSplitter();
};

moz2chTreeDataView.prototype.reset =
function () {
    this.element.treeBoxObject.view = this;
};

moz2chTreeDataView.prototype.syncSplitter =
function () {
    if (this.element)
        this.splitter.setAttribute("hidden",
                this.element.getAttribute("hidden"));
};

/////////////////////////
// implements nsITreeView
moz2chTreeDataView.prototype.getRowProperties = function (index, properties) {};
moz2chTreeDataView.prototype.getCellProperties = function (row, colID, properties) {};
moz2chTreeDataView.prototype.getColumnProperties = function (colID, colElt, properties) {};
moz2chTreeDataView.prototype.isContainer = function (index) {return false;};
moz2chTreeDataView.prototype.isContainerOpen = function (index) {return false;};
moz2chTreeDataView.prototype.isContainerEmpty = function (index) {return false;};
moz2chTreeDataView.prototype.isSeparator = function (index) {return false;};
moz2chTreeDataView.prototype.isSorted = function () {return false;};
moz2chTreeDataView.prototype.canDropOn = function (index) {return false;};
moz2chTreeDataView.prototype.canDropBeforeAfter = function (index) {return false;};
moz2chTreeDataView.prototype.drop = function (row, orientation) {};
moz2chTreeDataView.prototype.getParentIndex = function (rowIndex) {return -1;};
moz2chTreeDataView.prototype.hasNextSibling = function (rowIndex, afterIndex) {NOIMPL();};
moz2chTreeDataView.prototype.getLevel = function (index) {return 0;};
moz2chTreeDataView.prototype.getImageSrc = function (row, colID) {return "";};
moz2chTreeDataView.prototype.getProgressMode = function (row, colID) {return 3;};
moz2chTreeDataView.prototype.getCellValue = function (row, colID) {return "";};
moz2chTreeDataView.prototype.getCellText = function (row, colID) {NOIMPL();};
moz2chTreeDataView.prototype.setTree = function (tree) {};
moz2chTreeDataView.prototype.toggleOpenState = function(index) {};
moz2chTreeDataView.prototype.cycleHeader = function (colID, elt) {};
moz2chTreeDataView.prototype.selectionChanged = function () {};
moz2chTreeDataView.prototype.cycleCell = function (row, colID) {};
moz2chTreeDataView.prototype.isEditable = function (row, colID) {return false;};
moz2chTreeDataView.prototype.setCellText = function (row, colID, value) {};
moz2chTreeDataView.prototype.performAction = function (action) {};
moz2chTreeDataView.prototype.performActionOnRow = function (action, row) {};
moz2chTreeDataView.prototype.performActionOnCell = function (action, row, colID) {};
// to implement nsITreeView getter without hack.
moz2chTreeDataView.prototype.getRowCount = function () {NOIMPL();};

function NOIMPL() {
    alert(arguments.caller + "is not implemented!!");
}

